
String Firmware_Version = "Alexa_Device Version 1V0  18th Jan 2018"; 
#define SERIAL_BAUDRATE 115200
  // ----------------- Relay & AUX pin assignments  - Change to suit hardware build
byte Relay_Pin[] = {13,14,12};   // 3 relays pin assignments
byte AUX_Pin[] = {5,4,16};          // 3 AUX input pin assignments
const byte AP_Switch = 0;        // IO address of the AP enable switch
const byte Heartbeat_LED = 2;    // IO pin number for Heartbeat LED
const byte Buzzer = 14;  // IO pin used to drive buzzer when fitted for pump protection 
 // -------------------------- IO states - Change to suit hardware build --------------
const boolean LED_On = HIGH;   
const boolean LED_Off = !LED_On;
const boolean Relay_On = LOW; 
const boolean Relay_Off = !Relay_On;
const boolean Switch_On = LOW;       // Switch/buttons
const boolean Switch_Off = !Switch_On;
const boolean PIR_On = LOW;   
const boolean PIR_Off = !PIR_On;
  // -------------------------------------------------------------------------------
byte No_Of_Relays;   // variable used to define the number of relay outputs in operation
byte No_Of_AUX;      // variable used to define the number of AUX inputs in operation
String ssid = "....................";    // variable for storing the Access Point SSID
String esid;             // Variable for the WiFi Station log in SSID (stored in EEPROM)
String epass = "";       // Variable for the WiFi Station log in Password (stored in EEPROM)
String HostName = "...................." ;
String StoredString = "....................";
String passphrase =   "....................";
String st;
String content;
const byte Max_String_Length = 20;  // Max. no of characters allowed in any stored string. 
boolean Login_Successful;   // = true if WiFi login failed
unsigned long NTP_Time_Interval; // NTP time interval between updates in mS  
boolean NTP_Resolved;   // true if NTP has successfully set up soft clock
     // ------ Clock used to control the automatic Timer reset --------
boolean Timer_Reset_Enable = false;    // true = clock enabled
byte Timer_Reset_Clock_Mins;           // clock start = Timer Reset
byte Timer_Reset_Clock_Hrs;        
// byte Timer_Reset_Clock_Finish_Mins;          // clock finish = Timer Reset
// byte Timer_Reset_Clock_Finish_Hrs;

 // -----------------------------------------------------------------------------------------
            // EEPROM - direct byte addresses for EEPROM storage of configurable parameters
const unsigned int EEPROM_Start_Address = 0;      // starting address for EEPROM store (changing this moves the EEPROM block up/down the available memory range  
const unsigned int EEPROM_WiFi_SSID = EEPROM_Start_Address;   // start of Wifi SSID store - 20 bytes
const unsigned int EEPROM_WiFi_Password = EEPROM_WiFi_SSID + Max_String_Length;     // start of Wifi password - 20 bytes  
const unsigned int EEPROM_Relay_Descriptors = EEPROM_WiFi_Password  + Max_String_Length; // storage of Alexa output descripts - 80 bytes
const unsigned int EEPROM_Relay_On_Time_Parameter = EEPROM_Relay_Descriptors + (Max_String_Length * 4);  // ON time for switched outputs - 3 bytes
const unsigned int EEPROM_Output_Type = EEPROM_Relay_On_Time_Parameter + 3; // output switch type (normally open switch or changeover)- 3 bytes
const unsigned int EEPROM_AUX_Mode = EEPROM_Output_Type + 3;   // operating mode of AUX inputs if fitted - 3 bytes
const unsigned int EEPROM_PIR_Time = EEPROM_AUX_Mode + 3;     // switching time for PIR movement sensor - 2 bytes
const unsigned int EEPROM_HostName = EEPROM_PIR_Time + 2;     // Device network name - 20 bytes                                
const unsigned int EEPROM_Relay1_Timer1_TimOn_Min = EEPROM_HostName + Max_String_Length;     // Relay 1 Timer 1 Time ON minutes value
const unsigned int EEPROM_Relay1_Timer1_TimOn_Hrs = EEPROM_Relay1_Timer1_TimOn_Min + 1;      // Relay 1 Timer 1 Time ON hours value
const unsigned int EEPROM_Relay1_Timer1_TimOff_Min = EEPROM_Relay1_Timer1_TimOn_Hrs + 1;     // Relay 1 Timer 1 Time OFF minutes value
const unsigned int EEPROM_Relay1_Timer1_TimOff_Hrs = EEPROM_Relay1_Timer1_TimOff_Min + 1;    // Relay 1 Timer 1 Time OFF hours value
const unsigned int EEPROM_Relay1_Timer2_TimOn_Min = EEPROM_Relay1_Timer1_TimOff_Hrs + 1;     // Relay 1 Timer 2 Time ON minutes value
const unsigned int EEPROM_Relay1_Timer2_TimOn_Hrs = EEPROM_Relay1_Timer2_TimOn_Min + 1;      // Relay 1 Timer 2 Time ON hours value
const unsigned int EEPROM_Relay1_Timer2_TimOff_Min = EEPROM_Relay1_Timer2_TimOn_Hrs + 1;     // Relay 1 Timer 2 Time ON minutes value
const unsigned int EEPROM_Relay1_Timer2_TimOff_Hrs = EEPROM_Relay1_Timer2_TimOff_Min + 1;    // Relay 1 Timer 2 Time OFF hours value
const unsigned int EEPROM_Relay2_Timer1_TimOn_Min = EEPROM_Relay1_Timer2_TimOff_Hrs + 1;     // Relay 1 Timer 1 Time ON minutes value
const unsigned int EEPROM_Relay2_Timer1_TimOn_Hrs = EEPROM_Relay2_Timer1_TimOn_Min + 1;      // Relay 1 Timer 1 Time ON hours value
const unsigned int EEPROM_Relay2_Timer1_TimOff_Min = EEPROM_Relay2_Timer1_TimOn_Hrs + 1;     // Relay 1 Timer 1 Time OFF minutes value
const unsigned int EEPROM_Relay2_Timer1_TimOff_Hrs = EEPROM_Relay2_Timer1_TimOff_Min + 1;    // Relay 1 Timer 1 Time OFF hours value
const unsigned int EEPROM_Relay2_Timer2_TimOn_Min = EEPROM_Relay2_Timer1_TimOff_Hrs + 1;     // Relay 1 Timer 2 Time ON minutes value
const unsigned int EEPROM_Relay2_Timer2_TimOn_Hrs = EEPROM_Relay2_Timer2_TimOn_Min + 1;      // Relay 1 Timer 2 Time ON hours value
const unsigned int EEPROM_Relay2_Timer2_TimOff_Min = EEPROM_Relay2_Timer2_TimOn_Hrs + 1;     // Relay 1 Timer 2 Time OFF minutes value
const unsigned int EEPROM_Relay2_Timer2_TimOff_Hrs = EEPROM_Relay2_Timer2_TimOff_Min + 1;    // Relay 1 Timer 2 Time OFF hours value
const unsigned int EEPROM_Relay3_Timer1_TimOn_Min = EEPROM_Relay2_Timer2_TimOff_Hrs + 1;     // Relay 1 Timer 1 Time ON minutes value
const unsigned int EEPROM_Relay3_Timer1_TimOn_Hrs = EEPROM_Relay3_Timer1_TimOn_Min + 1;      // Relay 1 Timer 1 Time ON hours value
const unsigned int EEPROM_Relay3_Timer1_TimOff_Min = EEPROM_Relay3_Timer1_TimOn_Hrs + 1;     // Relay 1 Timer 1 Time OFF minutes value
const unsigned int EEPROM_Relay3_Timer1_TimOff_Hrs = EEPROM_Relay3_Timer1_TimOff_Min + 1;    // Relay 1 Timer 1 Time OFF hours value
const unsigned int EEPROM_Relay3_Timer2_TimOn_Min = EEPROM_Relay3_Timer1_TimOff_Hrs + 1;     // Relay 1 Timer 2 Time ON minutes value
const unsigned int EEPROM_Relay3_Timer2_TimOn_Hrs = EEPROM_Relay3_Timer2_TimOn_Min + 1;      // Relay 1 Timer 2 Time ON hours value
const unsigned int EEPROM_Relay3_Timer2_TimOff_Min = EEPROM_Relay3_Timer2_TimOn_Hrs + 1;     // Relay 1 Timer 2 Time OFF minutes value
const unsigned int EEPROM_Relay3_Timer2_TimOff_Hrs = EEPROM_Relay3_Timer2_TimOff_Min + 1;    // Relay 1 Timer 2 Time OFF hours value
const unsigned int EEPROM_Relay1_Timer1_Sun = EEPROM_Relay3_Timer2_TimOff_Hrs + 1;      // Relay 1 Timer 1 Sunday
const unsigned int EEPROM_Relay1_Timer1_Mon = EEPROM_Relay1_Timer1_Sun + 1;             // Relay 1 Timer 1 Monday
const unsigned int EEPROM_Relay1_Timer1_Tue = EEPROM_Relay1_Timer1_Mon + 1;             // Relay 1 Timer 1 Tuesday
const unsigned int EEPROM_Relay1_Timer1_Wed = EEPROM_Relay1_Timer1_Tue + 1;           
const unsigned int EEPROM_Relay1_Timer1_Thu = EEPROM_Relay1_Timer1_Wed + 1;          
const unsigned int EEPROM_Relay1_Timer1_Fri = EEPROM_Relay1_Timer1_Thu + 1;          
const unsigned int EEPROM_Relay1_Timer1_Sat = EEPROM_Relay1_Timer1_Fri + 1;    
const unsigned int EEPROM_Relay1_Timer2_Sun = EEPROM_Relay1_Timer1_Sat + 1;             // Relay 1 Timer 2 Sunday
const unsigned int EEPROM_Relay1_Timer2_Mon = EEPROM_Relay1_Timer2_Sun + 1;             // Relay 1 Timer 2 Monday
const unsigned int EEPROM_Relay1_Timer2_Tue = EEPROM_Relay1_Timer2_Mon + 1;             // Relay 1 Timer 2 Tuesday
const unsigned int EEPROM_Relay1_Timer2_Wed = EEPROM_Relay1_Timer2_Tue + 1;           
const unsigned int EEPROM_Relay1_Timer2_Thu = EEPROM_Relay1_Timer2_Wed + 1;          
const unsigned int EEPROM_Relay1_Timer2_Fri = EEPROM_Relay1_Timer2_Thu + 1;          
const unsigned int EEPROM_Relay1_Timer2_Sat = EEPROM_Relay1_Timer2_Fri + 1;   
const unsigned int EEPROM_Relay2_Timer1_Sun = EEPROM_Relay1_Timer2_Sat + 1;             // Relay 2 Timer 1 Sunday
const unsigned int EEPROM_Relay2_Timer1_Mon = EEPROM_Relay2_Timer1_Sun + 1;             // Relay 2 Timer 1 Monday
const unsigned int EEPROM_Relay2_Timer1_Tue = EEPROM_Relay2_Timer1_Mon + 1;             // Relay 2 Timer 1 Tuesday
const unsigned int EEPROM_Relay2_Timer1_Wed = EEPROM_Relay2_Timer1_Tue + 1;           
const unsigned int EEPROM_Relay2_Timer1_Thu = EEPROM_Relay2_Timer1_Wed + 1;          
const unsigned int EEPROM_Relay2_Timer1_Fri = EEPROM_Relay2_Timer1_Thu + 1;          
const unsigned int EEPROM_Relay2_Timer1_Sat = EEPROM_Relay2_Timer1_Fri + 1;    
const unsigned int EEPROM_Relay2_Timer2_Sun = EEPROM_Relay2_Timer1_Sat + 1;             // Relay 2 Timer 2 Sunday
const unsigned int EEPROM_Relay2_Timer2_Mon = EEPROM_Relay2_Timer2_Sun + 1;             // Relay 2 Timer 2 Monday
const unsigned int EEPROM_Relay2_Timer2_Tue = EEPROM_Relay2_Timer2_Mon + 1;             // Relay 2 Timer 2 Tuesday
const unsigned int EEPROM_Relay2_Timer2_Wed = EEPROM_Relay2_Timer2_Tue + 1;           
const unsigned int EEPROM_Relay2_Timer2_Thu = EEPROM_Relay2_Timer2_Wed + 1;          
const unsigned int EEPROM_Relay2_Timer2_Fri = EEPROM_Relay2_Timer2_Thu + 1;          
const unsigned int EEPROM_Relay2_Timer2_Sat = EEPROM_Relay2_Timer2_Fri + 1;      
const unsigned int EEPROM_Relay3_Timer1_Sun = EEPROM_Relay2_Timer2_Sat + 1;             // Relay 3 Timer 1 Sunday
const unsigned int EEPROM_Relay3_Timer1_Mon = EEPROM_Relay3_Timer1_Sun + 1;             // Relay 3 Timer 1 Monday
const unsigned int EEPROM_Relay3_Timer1_Tue = EEPROM_Relay3_Timer1_Mon + 1;             // Relay 3 Timer 1 Tuesday
const unsigned int EEPROM_Relay3_Timer1_Wed = EEPROM_Relay3_Timer1_Tue + 1;           
const unsigned int EEPROM_Relay3_Timer1_Thu = EEPROM_Relay3_Timer1_Wed + 1;          
const unsigned int EEPROM_Relay3_Timer1_Fri = EEPROM_Relay3_Timer1_Thu + 1;          
const unsigned int EEPROM_Relay3_Timer1_Sat = EEPROM_Relay3_Timer1_Fri + 1;    
const unsigned int EEPROM_Relay3_Timer2_Sun = EEPROM_Relay3_Timer1_Sat + 1;             // Relay 3 Timer 2 Sunday
const unsigned int EEPROM_Relay3_Timer2_Mon = EEPROM_Relay3_Timer2_Sun + 1;             // Relay 3 Timer 2 Monday
const unsigned int EEPROM_Relay3_Timer2_Tue = EEPROM_Relay3_Timer2_Mon + 1;             // Relay 3 Timer 2 Tuesday
const unsigned int EEPROM_Relay3_Timer2_Wed = EEPROM_Relay3_Timer2_Tue + 1;           
const unsigned int EEPROM_Relay3_Timer2_Thu = EEPROM_Relay3_Timer2_Wed + 1;          
const unsigned int EEPROM_Relay3_Timer2_Fri = EEPROM_Relay3_Timer2_Thu + 1;          
const unsigned int EEPROM_Relay3_Timer2_Sat = EEPROM_Relay3_Timer2_Fri + 1; 
const unsigned int EEPROM_Timer_Enable_Relay1 = EEPROM_Relay3_Timer2_Sat + 1;    // Timer enable - Relay 1
const unsigned int EEPROM_Timer_Enable_Relay2 = EEPROM_Timer_Enable_Relay1 + 1;  // Timer enable - Relay 2
const unsigned int EEPROM_Timer_Enable_Relay3 = EEPROM_Timer_Enable_Relay2 + 1;  // Timer enable - Relay 3
const unsigned int EEPROM_Enable_Messages = EEPROM_Timer_Enable_Relay3 + 1;      // disgnostic messages enable
const unsigned int EEPROM_No_Of_Relays = EEPROM_Enable_Messages + 1;
const unsigned int EEPROM_No_Of_AUX = EEPROM_No_Of_Relays + 1;
const unsigned int EEPROM_Soft_AP_Switch = EEPROM_No_Of_AUX + 1;  // No longer used
const unsigned int EEPROM_Timer_Reset_Clock_Mins = EEPROM_Soft_AP_Switch + 1;
const unsigned int EEPROM_Timer_Reset_Clock_Hrs = EEPROM_Timer_Reset_Clock_Mins + 1;
const unsigned int EEPROM_Timer_Reset_Clock_Finish_Mins = EEPROM_Timer_Reset_Clock_Hrs + 1;
const unsigned int EEPROM_Timer_Reset_Clock_Finish_Hrs = EEPROM_Timer_Reset_Clock_Finish_Mins + 1;
const unsigned int EEPROM_Timer_Reset_Enable = EEPROM_Timer_Reset_Clock_Finish_Hrs + 1;
const unsigned int EEPROM_Pump_Protection_Dry_Time = EEPROM_Timer_Reset_Enable + 1;
const unsigned int EEPROM_Pump_Protection_Start_Up_Delay_Time = EEPROM_Pump_Protection_Dry_Time + 1;
const unsigned int EEPROM_WatchDog_Type = EEPROM_Pump_Protection_Start_Up_Delay_Time + 1;
const unsigned int EEPROM_Alexa_Enable1 = EEPROM_WatchDog_Type + 1;
const unsigned int EEPROM_Alexa_Enable2 = EEPROM_Alexa_Enable1 + 1;
const unsigned int EEPROM_Alexa_Enable3 = EEPROM_Alexa_Enable2 + 1;
const unsigned int EEPROM_AP_Password = EEPROM_Alexa_Enable3 + 1;     // Access point password 20 bytes
const unsigned int EEPROM_Header_Block = EEPROM_AP_Password + + Max_String_Length;       // EEPROM header block 5 bytes


boolean WatchDog_Type;   // what type of watchdog is used
const boolean Hardware = true;
const boolean Software = !Hardware;
unsigned long Pump_Protection_Start_Up_Delay_Time;
unsigned long Pump_Protection_Dry_Time;
boolean Enable_Messages;    // true = enable diagnostic messages, false = mute messages
const byte TimerLimit = 240;  // max value of switch timer ON values
 // --------------- 3 arrays holding the Timer control parameters -------------------------
byte Relay1_Time_Control [2][2][2];   // arranged as  [TimerNo][TimON/TimOFF][Min,Hrs,]                                                                
byte Relay2_Time_Control [2][2][2];
byte Relay3_Time_Control [2][2][2];
 // --------------- Two dimensional array for each relay holding the day enable flags --------
boolean Relay1_Time_Control_Day_Flags [2][7];  // arranged as  [TimerNo][Week day]                                                                            
boolean Relay2_Time_Control_Day_Flags [2][7];
boolean Relay3_Time_Control_Day_Flags [2][7];
boolean Timer_Enable[3];  // Timer enable flag for each relay(3)
boolean Soft_AP_Switch;  // true = Access point will run 
byte Relay_On_Time_Parameter[3];   // ON time period variable for upto 3 physical outputs when switched - 0 = timer disabled
String Relay_Descriptors[4] {  // working memory array of Alexa voice control names for relays & AP wake up
"....................", "....................", "....................", "...................."};
byte PIR_Time;    // ON switching time for PIR movement sensor - stored in EEPROM
byte AUX_Mode [3];   // mode for each AUX input - 0 = disabled, 1 = lamp switching on movement detect, 2 = Pump Protection, 3 = manual switch
byte Relay_On_Timers[3];    // ON timer for each output when switched 

unsigned long Timer_Tick;     // used as timer for one minute timed operations. E.g. Output timers

      // virtual copy of each relay output state
boolean Alexa_Enable[3];   // true = voice control enabled for each output

         // Soft clock & date time elements
byte Clock_Minute;
byte Clock_Hour;
byte Clock_Week_Day = 0;

unsigned long Time_Start;   // used in boolean Check_AP_Switch(unsigned long Debounce)
                            // stores start time (ms) when button is pressed

ESP8266WebServer serverAP(80);

  // --------------------------------------------------------------------------
void Download_From_EEPROM_Relay_Descriptor (byte Output_No)  // download from EEPROM to working memory
{                                                             // the text names of each relay  
  unsigned int EEPROM_Address_Offset = EEPROM_Relay_Descriptors + ((Output_No) * Max_String_Length);
  unsigned int i = EEPROM_Address_Offset;
  StoredString = "";
  while(i < EEPROM_Address_Offset + Max_String_Length)
  {   
    if (EEPROM.read(i) != 255) StoredString += char(EEPROM.read(i)); else break;
    i++; 
  }
   Relay_Descriptors[Output_No] = StoredString;
}
// ------------------------------------------------------------
void Download_From_EEPROM_Relay_Descriptors(boolean Display)
{
  byte i= 0;
  while (i < No_Of_Relays)
  {
    Download_From_EEPROM_Relay_Descriptor (i);  
    if (Display)
    {
      Serial.print( F("Output: ")); 
      Serial.print(i+1); 
      Serial.print(F(" Description = ")); 
      Serial.println(Relay_Descriptors[i]);
    } // end of if (Display)
    i ++;
  }  // end of while (i < No_Of_Relays) 
}  // end of void Download_From_EEPROM_Relay_Descriptors(boolean Display)
  // ------------------------------------------------------------------
void Heartbeat_Tick()   // short heatbeat tick to keep the HW watchdog alive
{
  digitalWrite(Heartbeat_LED, LED_On);
  delay(10);
  digitalWrite(Heartbeat_LED, LED_Off); 
  delay(10);   
}
// ------------------------------------------------------------
void Download_From_EEPROM_Timer_Control_Parameters(boolean Display)  // display = false = suppress Special messages
 {        // download from EEPROM to working memory the timer control parameters
    const byte Timer_On = 0;
    const byte Timer_Off = 1;
    const byte Mins = 0;
    const byte Hrs = 1;
    
     // -------------------- Relay 1 ----------------------------------------------
    byte Timer_No = 0;
    Relay1_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay1_Timer1_TimOn_Min);
    Relay1_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay1_Timer1_TimOn_Hrs); 
    Relay1_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay1_Timer1_TimOff_Min); 
    Relay1_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay1_Timer1_TimOff_Hrs); 

    if(Display)
    {
      Serial.println("");
      Serial.print("Relay 1 Timer 1:");
      Serial.print("   Time On = "); Serial.print(Relay1_Time_Control[Timer_No][Timer_On][Hrs]); 
      Serial.print(":"); 
      if(Relay1_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0"); 
      Serial.print(Relay1_Time_Control[Timer_No][Timer_On][Mins]);     
      Serial.print("   Time Off = "); Serial.print(Relay1_Time_Control[Timer_No][Timer_Off][Hrs]); 
      Serial.print(":"); 
      if(Relay1_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
      Serial.println(Relay1_Time_Control[Timer_No][Timer_Off][Mins]); 
    }
        
    Timer_No = 1;
    Relay1_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay1_Timer2_TimOn_Min); 
    Relay1_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay1_Timer2_TimOn_Hrs); 
    Relay1_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay1_Timer2_TimOff_Min); 
    Relay1_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay1_Timer2_TimOff_Hrs); 
    
    if(Display)
    {
      Serial.print("Relay 1 Timer 2:");     
      Serial.print("   Time On = "); Serial.print(Relay1_Time_Control[Timer_No][Timer_On][Hrs]); 
      Serial.print(":"); 
      if(Relay1_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0");      
      Serial.print(Relay1_Time_Control[Timer_No][Timer_On][Mins]); 
      Serial.print("   Time Off = "); Serial.print(Relay1_Time_Control[Timer_No][Timer_Off][Hrs]); 
      Serial.print(":"); 
      if(Relay1_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");   
      Serial.println(Relay1_Time_Control[Timer_No][Timer_Off][Mins]); 
    }  
     
    // ------------------------- Relay 2 -------------------------------------------  
    if (No_Of_Relays >=2)   // only if 2 or 3 relays fitted
    {
      Timer_No = 0;
      Relay2_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay2_Timer1_TimOn_Min); 
      Relay2_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay2_Timer1_TimOn_Hrs);    
      Relay2_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay2_Timer1_TimOff_Min); 
      Relay2_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay2_Timer1_TimOff_Hrs); 
    
      if(Display)
      {
        Serial.print("Relay 2 Timer 1:");
        Serial.print("   Time On = "); Serial.print(Relay2_Time_Control[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay2_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0");       
        Serial.print(Relay2_Time_Control[Timer_No][Timer_On][Mins]);     
        Serial.print("   Time Off = "); Serial.print(Relay2_Time_Control[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay2_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");        
        Serial.println(Relay2_Time_Control[Timer_No][Timer_Off][Mins]); 
      }  
      
      Timer_No = 1;;
      Relay2_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay2_Timer2_TimOn_Min); 
      Relay2_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay2_Timer2_TimOn_Hrs); 
      Relay2_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay2_Timer2_TimOff_Min); 
      Relay2_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay2_Timer2_TimOff_Hrs); 
    
      if (Display)
      {
        Serial.print("Relay 2 Timer 2:");    
        Serial.print("   Time On = "); Serial.print(Relay2_Time_Control[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay2_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay2_Time_Control[Timer_No][Timer_On][Mins]); 
        Serial.print("   Time Off = "); Serial.print(Relay2_Time_Control[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay2_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");        
        Serial.println(Relay2_Time_Control[Timer_No][Timer_Off][Mins]); 
      }
    } // end of if (No_Of_Relays >=2)
    
    // ---------------------- Relay 3 -----------------------------------------   
    if (No_Of_Relays == 3)       // only if 3 relays fitted
    {
      Timer_No = 0;  
      Relay3_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay3_Timer1_TimOn_Min); 
      Relay3_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay3_Timer1_TimOn_Hrs); 
      Relay3_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay3_Timer1_TimOff_Min); 
      Relay3_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay3_Timer1_TimOff_Hrs); 
    
      if(Display)
      {
        Serial.print("Relay 3 Timer 1:"); 
        Serial.print("   Time On = "); Serial.print(Relay3_Time_Control[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay3_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay3_Time_Control[Timer_No][Timer_On][Mins]);        
        Serial.print("   Time Off = "); Serial.print(Relay3_Time_Control[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay3_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
        Serial.println(Relay3_Time_Control[Timer_No][Timer_Off][Mins]);     
      }
      
      Timer_No = 1;;
      Relay3_Time_Control[Timer_No][Timer_On][Mins] = EEPROM.read(EEPROM_Relay3_Timer2_TimOn_Min); 
      Relay3_Time_Control[Timer_No][Timer_On][Hrs] = EEPROM.read(EEPROM_Relay3_Timer2_TimOn_Hrs);    
      Relay3_Time_Control[Timer_No][Timer_Off][Mins] = EEPROM.read(EEPROM_Relay3_Timer2_TimOff_Min); 
      Relay3_Time_Control[Timer_No][Timer_Off][Hrs] = EEPROM.read(EEPROM_Relay3_Timer2_TimOff_Hrs);    
   // ------------------------------------------------------------------------------
      if(Display)
      {
        Serial.print("Relay 3 Timer 2:");
        Serial.print("   Time On = "); Serial.print(Relay3_Time_Control[Timer_No][Timer_On][Hrs]); 
        Serial.print(":"); 
        if(Relay3_Time_Control[Timer_No][Timer_On][Mins] < 10) Serial.print("0");        
        Serial.print(Relay3_Time_Control[Timer_No][Timer_On][Mins]); 
        Serial.print("   Time Off = "); Serial.print(Relay3_Time_Control[Timer_No][Timer_Off][Hrs]); 
        Serial.print(":"); 
        if(Relay3_Time_Control[Timer_No][Timer_Off][Mins] < 10) Serial.print("0");       
        Serial.println(Relay3_Time_Control[Timer_No][Timer_Off][Mins]); 
      }
    } // end of     if (No_Of_Relays == 3)
    
   byte Day;   // pointer
   if(Display) Serial.println("");  
   
   Timer_No = 0;
   while (Timer_No < 2)  // for each of 2 timers per output
   {
      if(Display)
      {
         Serial.print("Relay 1 Timer "); 
         Serial.print (Timer_No+1);
         Serial.print (" Enabled days:  ");
      }
 
    Day = 0;
    while (Day < 7)   // read each timer day flag from EEPROM
     {
        Relay1_Time_Control_Day_Flags[Timer_No][Day] = EEPROM.read(EEPROM_Relay1_Timer1_Sun + (Timer_No*7) + Day);
        if(Display)
        {
            Serial.print(Relay1_Time_Control_Day_Flags[Timer_No][Day]); 
            Serial.print(":");
        }
        Day ++;   
     }     // end of while (Day < 7)   // read each timer day flag from EEPROM
     if(Display)
     {
        Serial.println("");
     }
     Timer_No ++;
   }       // end of while (Timer_No < 2)  // for each of 2 timers per output
  
   
   if (No_Of_Relays >= 2)  // only if 2 or 3 relays fitted
   {
      Timer_No = 0;
      while (Timer_No < 2)  // for each of 2 timers per output
      {
        if(Display)
        {
            Serial.print("Relay 2 Timer "); 
            Serial.print (Timer_No+1);
            Serial.print (" Enabled days:  ");
        }
     
        Day = 0;
        while (Day < 7)   // read each timer day flag from EEPROM
        {
            Relay2_Time_Control_Day_Flags[Timer_No][Day] = EEPROM.read(EEPROM_Relay2_Timer1_Sun + (Timer_No*7) + Day);
            if(Display)
            {
                Serial.print(Relay2_Time_Control_Day_Flags[Timer_No][Day]); 
                Serial.print(":");
            }
            Day ++;   
        }     // end of while (Day < 7)   // read each timer day flag from EEPROM
     
        if(Display) Serial.println("");
   
        Timer_No ++;
      } // end of while (Timer_No < 2)  // for each of 2 timers per output 
   } // end of if(No_Of_Relays >=2)

   if (No_Of_Relays == 3)     // only if 3 relays fitted
   {
      Timer_No = 0;
      while (Timer_No < 2)  // for each of 2 timers per output
      {
        if(Display)
        {
            Serial.print("Relay 3 Timer "); 
            Serial.print (Timer_No+1); 
            Serial.print (" Enabled days:  ");
        }
     
        Day = 0;
        while (Day < 7)   // read each timer day flag from EEPROM
        {
            Relay3_Time_Control_Day_Flags[Timer_No][Day] = EEPROM.read(EEPROM_Relay3_Timer1_Sun + (Timer_No*7) + Day);
        
            if(Display)
            {       
                Serial.print(Relay3_Time_Control_Day_Flags[Timer_No][Day]); 
                Serial.print(":");
            }
        
            Day ++;   
        }     // end of while (Day < 7)   // read each timer day flag from EEPROM
     
        if(Display)  Serial.println("");
     
        Timer_No ++;
      }       // end of while (Timer_No < 2)  // for each of 2 timers per output 
   } // end of if (size of (Relay_Pin == 3)
  
  if(Display)
  {
    Serial.println(""); Serial.println("Timer status");
  }
  
    Timer_Enable[0] = EEPROM.read(EEPROM_Timer_Enable_Relay1); 
    if(No_Of_Relays>= 2) Timer_Enable[1] = EEPROM.read(EEPROM_Timer_Enable_Relay2);
    if(No_Of_Relays== 3) Timer_Enable[2] = EEPROM.read(EEPROM_Timer_Enable_Relay3);
    
    if (Display)
    {
       Serial.print(F("Relay 1 Timer is ")); 
       if (Timer_Enable[0]) Serial.println(F("enabled")); else Serial.println(F("disabled"));
       if(No_Of_Relays>= 2) 
       {
         Serial.print(F("Relay 2 Timer is ")); 
       if (Timer_Enable[1]) Serial.println(F("enabled")); else Serial.println(F("disabled"));
       }
       if(No_Of_Relays== 3) 
       {
         Serial.print(F("Relay 3 Timer is ")); 
       if (Timer_Enable[2]) Serial.println(F("enabled")); else Serial.println(F("disabled"));             
       }
    }
    if (Display) Serial.println("");  
 }   // end of  void Download_From_EEPROM_Timer_Control_Parameters()
  // -------------------------------------------------------------------- 
void Download_From_EEPROM_Output_And_Input_Settings(boolean Display)   
{   // download from EEPROM to working memory the relay ON timer and AUX parameters
 unsigned int i = 0;
 byte Value;
 while (i < No_Of_Relays)   // download the output timer settings
 {
    Value = EEPROM.read(EEPROM_Relay_On_Time_Parameter+i);
    if (Value <= TimerLimit) Relay_On_Time_Parameter[i] = Value; else  Relay_On_Time_Parameter[i] = 0;
    if (Display)
    { 
      Serial.print(F("Output ")); 
      Serial.print(i+1); 
      Serial.print(F(" Timer = ")); 
      Serial.print(Relay_On_Time_Parameter[i]); Serial.println(F(" Minutes"));
    } 
    i++;
 }
  if (Display) Serial.println(""); 
  i = 0;
  if (No_Of_AUX > 0) // if AUX input's are enabled (>0)
 {
    while (i < No_Of_AUX)  // download the AUX input settings
    {
      AUX_Mode[i] = EEPROM.read(EEPROM_AUX_Mode+i); 
      if (Display)
      {  
         Serial.print(F("AUX Input ")); Serial.print(i+1); 
        if (AUX_Mode[i] == 0) Serial.println(F(" = Disabled")); 
        if (AUX_Mode[i] == 1) Serial.println(F(" = PIR Movement Sensor")); 
        if (AUX_Mode[i] == 2) Serial.println(F(" = Pump Protection Sensor")); 
        if (AUX_Mode[i] == 3) Serial.println(F(" = Manual On/Off control Switch"));         
        if (AUX_Mode[i] > 3)  Serial.println(F(" setting is invalid"));
      }
      i++;
    } // end of  while (i < No_Of_AUX)  // download the AUX settings
 

    PIR_Time = EEPROM.read(EEPROM_PIR_Time);
    if (Display)
    { 
        Serial.print(F("PIR Timer set to ")); 
        Serial.print(PIR_Time); 
        Serial.println(F(" minutes")); 
        Serial.println("");
    }
    Pump_Protection_Start_Up_Delay_Time = EEPROM.read(EEPROM_Pump_Protection_Start_Up_Delay_Time) * 1000;
    Pump_Protection_Dry_Time = EEPROM.read(EEPROM_Pump_Protection_Dry_Time) * 1000;
    if (Display)
    { 
        Serial.print(F("Pump Protection Start Up Delay (secs) = ")); 
        Serial.println(EEPROM.read(EEPROM_Pump_Protection_Start_Up_Delay_Time));
        Serial.print(F("Pump Protection Dry Run Delay (secs) = ")); 
        Serial.println(EEPROM.read(EEPROM_Pump_Protection_Dry_Time));      
    }   
 } // end of if (No_Of_AUX >0]
 else
 if (Display)
    { 
        Serial.print(F("AUX inputs are not fitted")); 
        Serial.println("");
    }
}   // end of void Download_From_EEPROM_Output_And_Input_Settings()
// ------------------------------------------------------------
void Download_Timer_Reset_Clock_From_EEPROM(boolean Display)
{
  Timer_Reset_Clock_Hrs   = EEPROM.read(EEPROM_Timer_Reset_Clock_Hrs);
  Timer_Reset_Clock_Mins  = EEPROM.read(EEPROM_Timer_Reset_Clock_Mins);
  Timer_Reset_Enable = EEPROM.read(EEPROM_Timer_Reset_Enable);
  if(Display)
  {
     Serial.print("Automatic Timer Reset Function is ");
     if(Timer_Reset_Enable) Serial.println(F("Enabled")); else Serial.println(F("Disabled"));
     Serial.print("Set Time = "); Serial.print(Timer_Reset_Clock_Hrs); 
     Serial.print(":"); 
     if (Timer_Reset_Clock_Mins < 10 ) Serial.print('0'); 
     Serial.println(Timer_Reset_Clock_Mins); 
  }  
}  // end of void Download_Timer_Reset_Clock_From_EEPROM()
// ------------------------------------------------------------
void Activate_Relay(byte Output_No, boolean State, boolean Set_Output_Timer)  
                // Output_No = 0-2 = relay 1 to 3, Set_Ouput_Timer instructs
                // function to set the output timer to required value if flag = true
{     // set or reset the addressed relay & the virtual copy of the relay state
  digitalWrite(Relay_Pin[Output_No], State);   // activate relay
  if (State == Relay_On)   // if relay is to be switched on
  {
    if(Set_Output_Timer)
    {
      Relay_On_Timers[Output_No] = Relay_On_Time_Parameter[Output_No];  // set output timer to required value
    }
    else
    {
     Relay_On_Timers[Output_No] = 0;    // disable output timer 
    }
    Timer_Tick = millis();  // reset timer tick                          // reset output timer clock
  }  // end of   if (State)   // if relay switched on
}    // end of void Activate_Relay(byte Output_No, boolean State, boolean Set_Output_Timer) 
// ------------------------------------------------------------
void Reset_Device(String Reason)  // Reset the device - method depends on whether HW watchdog is fitted
{
 WiFi.softAPdisconnect(true);     // precautionary. Ensure that the soft Access point server is disconnected
 WiFi.mode(WIFI_STA);             // Set WIFI module to STA mode 
 delay(100);
 if (Enable_Messages)
 {
    Serial.print("Forced reset -  ");
    Serial.println(Reason);
 }
 if (WatchDog_Type == Hardware)
  {
    Serial.println(F("Reset by external hardware watchdog"));
    while(true) // hang up and let the hardware watchdog kick in after some seconds
    {
      delay(1);
    }
  }  // end of  if (WatchDog_Type == Hardware)
 else        // HW watchdog not fitted so use internal reset command
  {
    Serial.println(F("Reset by Software"));
    ESP.reset();  
    while(true)
    {
      delay(10);
    }
  }  // end of else  
} // end of void Reset_Device(String Reason)
  // -------------------------------------------------------------------
String Control_Timer_Time_To_String (byte Relay_No, byte TimerNo, byte TimeOn_Off )
{             // convert the Timer control parameter to a string value (for web page display)
  String T ;
  String T1;
  switch (Relay_No)
  {
    case 0:
    T =  String(Relay1_Time_Control[TimerNo][TimeOn_Off][1]);   // convert hours
    if (T.length() == 1) T = "0" + T;                           // if single digit add leading zero
    T1 = String(Relay1_Time_Control[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                        // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break;
    case 1:
    T =  String(Relay2_Time_Control[TimerNo][TimeOn_Off][1]);             // convert hours
    if(T.length() == 1) T = "0" + T;                            // if single digit add leading zero
    T1 = String(Relay2_Time_Control[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                            // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break; 
    case 2:
    T =  String(Relay3_Time_Control[TimerNo][TimeOn_Off][1]);             // convert hours
    if(T.length() == 1) T = "0" + T;                                  // if single digit add leading zero
    T1 = String(Relay3_Time_Control[TimerNo][TimeOn_Off][0]);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                           // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator
    break; 
  } // end of Switch (Relay_No)
  return T;   
} // end of String Control_Timer_Time_To_String(byte Relay_No, byte TimerNo, byte TimeOn_Off, ) 
// -----------------------------------------------------------------------------
String Timer_Reset_Clock_Time_To_String ()   
{             // convert the Master Clock parameters to a string value (for web page display)
  String T ;
  String T1;
    T =  String(Timer_Reset_Clock_Hrs);   // convert hours
    if (T.length() == 1) T = "0" + T;                           // if single digit add leading zero
    T1 = String(Timer_Reset_Clock_Mins);   // convert minutes
    if (T1.length() == 1) T1 = "0" + T1;                        // if single digit add leading zero
    T = T + ":" + T1;           // combine digits with separator  
  return T;
} // end of String Timer_Reset_Clock_Time_To_String ()   // 0 = start, 1 = Finish
// -----------------------------------------------------------------------------
void Timer_Page_Relay1()   // Common page layout for Output timer 1 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1;
        const byte Timer1 = 0;
        const byte Timer2 = 1;  
        const byte Relay1 = 0;      
        String Tim1 = Control_Timer_Time_To_String(Relay1,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay1,Timer1, TimeOff);
        
        content += "<h3>" + HostName + " - Relay 1 (";
        content += Relay_Descriptors[0] + ") - Timed Control Program</h3>";   
        content += "<form action = 'setting2'>";
        
        content += "<fieldset>";  
        content += "<legend><b>TIMER 1</b></legend>";     
        content += "<p>Timer 1 ON: <input type = 'time' name = 'Relay1_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay1_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Sunday' value = '1' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][0]) content += " checked";
        content += ">Sunday"; 
              
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Monday'  value = '2' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][1]) content += " checked";
        content += ">Monday"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Tuesday' value = '3' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][2]) content += " checked";
        content += ">Tuesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Wednesday'  value = '4' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][3]) content += " checked";
        content += ">Wednesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Thursday' value = '5' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][4]) content += " checked";
        content += ">Thursday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Friday'  value = '6' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][5]) content += " checked";
        content += ">Friday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer1_Saturday' value = '7' ";
        if (Relay1_Time_Control_Day_Flags[Timer1][6]) content += " checked";
        content += ">Saturday";         
        content += "</fieldset>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 2</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(Relay1,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(Relay1,Timer2, TimeOff);       
        content += "<p>Timer 2 ON: <input type = 'time' name = 'Relay1_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay1_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Sunday' value = '1' ";
        if(Relay1_Time_Control_Day_Flags[Timer2][0]) content += " checked";                
        content += ">Sunday";
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Monday'  value = '2' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][1]) content += " checked";        
        content += ">Monday";
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Tuesday' value = '3' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][2]) content += " checked";
        content += ">Tuesday";
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Wednesday'  value = '4' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][3]) content += " checked";
        content += ">Wednesday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Thursday' value = '5' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][4]) content += " checked";
        content += ">Thursday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Friday'  value = '6' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][5]) content += "checked";
        content += ">Friday";
                
        content += "<br><input type = 'checkbox' name = 'Relay1_Timer2_Saturday' value = '7' ";
        if (Relay1_Time_Control_Day_Flags[Timer2][6]) content += " checked";
        content += ">Saturday";        
        content += "</fieldset>";
                     
        content += "<p><h3>Switch Operational Mode</h3>";
        content += "<input type = 'radio' name = 'Relay1_Mode' value = '0' "; 
        if (!Timer_Enable[Relay1]) content += "checked";
        content += ">Timer Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay1_Mode' value = '1' ";  
        if (Timer_Enable[Relay1]) content += "checked";
        content += ">Timer Control Enabled<br>";
                                 
        content += "<p><br> <input type = 'submit' value = 'Press to upload'>";
        content += "<p><a href='http://192.168.8.200'>Return to the Main Configuration Menu page </a>";   
        content += "</form> </html>";    
}   // end of void Timer_Page_Relay1()   // Common page layout for Output timer 1 set up
        // ----------------------------------------------------------------------- 
void Timer_Page_Relay2()   // Common page layout for Output timer 1 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1;
        const byte Timer1 = 0;
        const byte Timer2 = 1;
        const byte Relay2 = 1;
        String Tim1 = Control_Timer_Time_To_String(Relay2,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay2,Timer1, TimeOff);
        
        content += "<h3>" + HostName + " - Relay 2 (";
        content += Relay_Descriptors[1] + ") - Timed Control Program</h3>";   
        content += "<form action = 'setting4'>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 1</b></legend>";         
        content += "<p>Timer 1 ON: <input type = 'time' name = 'Relay2_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay2_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Sunday' value = '1' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][0]) content += " checked";
        content += ">Sunday"; 
              
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Monday'  value = '2' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][1]) content += " checked";
        content += ">Monday"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Tuesday' value = '3' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][2]) content += " checked";
        content += ">Tuesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Wednesday'  value = '4' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][3]) content += " checked";
        content += ">Wednesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Thursday' value = '5' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][4]) content += " checked";
        content += ">Thursday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Friday'  value = '6' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][5]) content += " checked";
        content += ">Friday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer1_Saturday' value = '7' ";
        if (Relay2_Time_Control_Day_Flags[Timer1][6]) content += " checked";
        content += ">Saturday";  
        content += "</fieldset>";
           
        content += "<fieldset>";  
        content += "<legend><b>TIMER 2</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(1,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(1,Timer2, TimeOff);       
        content += "<p>Timer 2 ON: <input type = 'time' name = 'Relay2_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay2_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Sunday' value = '1' ";
        if(Relay2_Time_Control_Day_Flags[Timer2][0]) content += " checked";                
        content += ">Sunday";
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Monday'  value = '2' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][1]) content += " checked";        
        content += ">Monday";
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Tuesday' value = '3' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][2]) content += " checked";
        content += ">Tuesday";
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Wednesday'  value = '4' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][3]) content += " checked";
        content += ">Wednesday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Thursday' value = '5' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][4]) content += " checked";
        content += ">Thursday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Friday'  value = '6' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][5]) content += "checked";
        content += ">Friday";
                
        content += "<br><input type = 'checkbox' name = 'Relay2_Timer2_Saturday' value = '7' ";
        if (Relay2_Time_Control_Day_Flags[Timer2][6]) content += " checked";
        content += ">Saturday";  
        content += "</fieldset>";                
                     
        content += "<p><h3>Switch Operational Mode</h3>";
        content += "<input type = 'radio' name = 'Relay2_Mode' value = '0' "; 
        if (!Timer_Enable[Relay2]) content += "checked";
        content += ">Timer Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay2_Mode' value = '1' ";  
        if (Timer_Enable[Relay2]) content += "checked";
        content += ">Timer Control Enabled<br>";
                                 
        content += "<p><br> <input type = 'submit' value = 'Press to upload'>";
        content += "<p><a href='http://192.168.8.200'>Return to the Main Configuration Menu page </a>";   
        content += "</form> </html>";    
}   // end of void Timer_Page_Relay2()   // Common page layout for Output timer 2 set up
  // ---------------------------------------------------------------------------------
void Timer_Page_Relay3()   // Common page layout for Output timer 3 set up
{
        const byte TimeOn = 0;
        const byte TimeOff =1;
        const byte Timer1 = 0;
        const byte Timer2 = 1;
        const byte Relay3 = 2;
        String Tim1 = Control_Timer_Time_To_String(Relay3,Timer1, TimeOn);    // convert time values to a string
        String Tim2 = Control_Timer_Time_To_String(Relay3,Timer1, TimeOff);
        
        content += "<h3>" + HostName + " - Relay 3 (";
        content += Relay_Descriptors[2] + ") - Timed Control Program</h3>";    
        content += "<form action = 'setting5'>";

        content += "<fieldset>";  
        content += "<legend><b>TIMER 1</b></legend>";        
        content += "<p>Timer 1 ON: <input type = 'time' name = 'Relay3_Timer_1_ON'  value = ";
        content += Tim1 + ">";      
        content += "&nbsp Timer 1 OFF: <input type = 'time' name = 'Relay3_Timer_1_OFF' value = ";
        content += Tim2 + ">"; 
                   
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Sunday' value = '1' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][0]) content += " checked";
        content += ">Sunday"; 
              
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Monday'  value = '2' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][1]) content += " checked";
        content += ">Monday"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Tuesday' value = '3' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][2]) content += " checked";
        content += ">Tuesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Wednesday'  value = '4' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][3]) content += " checked";
        content += ">Wednesday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Thursday' value = '5' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][4]) content += " checked";
        content += ">Thursday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Friday'  value = '6' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][5]) content += " checked";
        content += ">Friday"; 
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer1_Saturday' value = '7' ";
        if (Relay3_Time_Control_Day_Flags[Timer1][6]) content += " checked";
        content += ">Saturday";
        content += "</fieldset>"; 
                         
        content += "<fieldset>";  
        content += "<legend><b>TIMER 2</b></legend>"; 
        Tim1 = Control_Timer_Time_To_String(Relay3,Timer2, TimeOn);    // convert time values to a string
        Tim2 = Control_Timer_Time_To_String(Relay3,Timer2, TimeOff);       
        content += "<p>Timer 2 ON: <input type = 'time' name = 'Relay3_Timer_2_ON' value = ";
        content += Tim1 + ">"; 
        content += "&nbsp Timer 2 OFF: <input type = 'time' name = 'Relay3_Timer_2_OFF' value = "; 
        content += Tim2 + ">"; 
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Sunday' value = '1' ";
        if(Relay3_Time_Control_Day_Flags[Timer2][0]) content += " checked";                
        content += ">Sunday";
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Monday'  value = '2' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][1]) content += " checked";        
        content += ">Monday";
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Tuesday' value = '3' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][2]) content += " checked";
        content += ">Tuesday";
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Wednesday'  value = '4' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][3]) content += " checked";
        content += ">Wednesday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Thursday' value = '5' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][4]) content += " checked";
        content += ">Thursday";        
        
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Friday'  value = '6' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][5]) content += "checked";
        content += ">Friday";
                
        content += "<br><input type = 'checkbox' name = 'Relay3_Timer2_Saturday' value = '7' ";
        if (Relay3_Time_Control_Day_Flags[Timer2][6]) content += " checked";
        content += ">Saturday"; 
        content += "</fieldset>";                 
                     
        content += "<p><h3>Switch Operational Mode</h3>";
        content += "<input type = 'radio' name = 'Relay3_Mode' value = '0' "; 
        if (!Timer_Enable[Relay3]) content += "checked";
        content += ">Timer Control Disabled<br>";
        
        content += "<input type = 'radio' name = 'Relay3_Mode' value = '1' ";  
        if (Timer_Enable[Relay3]) content += "checked";
        content += ">Timer Control Enabled<br>";
                                 
        content += "<p><br> <input type = 'submit' value = 'Press to upload'>";
        content += "<p><a href='http://192.168.8.200'>Return to the Main Configuration Menu page </a>";   
        content += "</form> </html>";    
}   // end of void Timer_Page_Relay3()   // Common page layout for Output timer 1 set up
   // ---------------------------------------------------------------------------- 
byte Get_Decimal_Hours_From_Web_Time_Value(String Time_Value)   // Input string = hrs:min(xx:yy) format from Access point web page input.
{                                                               // Returns decimal value. Input must be in the correct format
  byte Decimal_Value; 
  String Hours = String(Time_Value.charAt(0));
  Hours += String(Time_Value.charAt(1));
  Decimal_Value = Hours.toInt();
  return Decimal_Value;
}   // end of byte Get_Decimal_Hours_From_Web_Time_Value(String Time_Value) 
   // ----------------------------------------------------------------------------   
byte Get_Decimal_Mins_From_Web_Time_Value(String Time_Value)   // Input string = hrs:min(xx:yy) format from Access point web page input.
{                                                              // Returns decimal value.  Input must be in the correct format
  byte Decimal_Value;  
  String Minutes = String(Time_Value.charAt(3));
  Minutes += String(Time_Value.charAt(4));
  Decimal_Value = Minutes.toInt();
  return Decimal_Value;  
}   // end of  byte Get_Decimal_Mins_From_Web_Time_Value(String Time_Value) 
   // ----------------------------------------------------------------------------   
byte Convert_From_String_To_Decimal_Number(String String_Number)   // Input string number = xxx format from Access point web page input 
{                                                                  // (max value = 256). Returns decimal value
  unsigned int Decimal_Value;
  if (String_Number.length() > 3) 
  {  // String too many characters
    Decimal_Value = 0;
  }
  else 
  {
    Decimal_Value = String_Number.toInt();   // convert string to int (must be numeric string!)
    if (Decimal_Value > 255) Decimal_Value = 255;  
  }
  return byte(Decimal_Value);   
}   // end of byte Convert_From_String_To_Decimal_Number(String String_Number)   
   // ---------------------------------------------------------------------------- 
void Success_Message(boolean Reset)
{
  // ----------- Display after a sucessful update of any required parameter page-----------------     
  content = "<!DOCTYPE HTML>\r\n<html><form>";
  content += "<br>Success: Data has been uploaded to the device";
  if(Reset) content += "<br>The device will now reset to implement the changes";
  else
  {
    content += "<br><b><i>Note that the device will need resetting ";
    content += "<br>before any new WiFi and/or Alexa output names";
    content += "<br>will become active</b></i><br>"; 
    content += "<p><br><a href='http://192.168.8.200'> Return to the Main Configuration Menu page  </a>"; 
  }
  content += "</form></html>";
  serverAP.send(200, "text/html", content);
  delay(2000);
  if(Reset) Reset_Device("Required by Configuration page"); 
}  
  // ----------------------------------------------------------------------------
void Upload_Device_Configuration_Web_Page()  // Uploads the login web page to the AP and processes any data entry
{
    serverAP.on("/", []() // Configuration Menu page
    {
      content = "<!DOCTYPE HTML> <html>";    
      content += "<form>";        
      content += "<h3>" + HostName + " Setup Menu</h3>";
      content += Firmware_Version + "<br>";

      content+= "Current clock time = ";
      content += String(Clock_Hour) + ":";      
      if (Clock_Minute > 9) content += String(Clock_Minute);
      else content += "0" + String(Clock_Minute);
      
      switch (Clock_Week_Day)
      {
      case 1:
      content += " Sunday, ";
      break;
      case 2: 
      content += " Monday, ";
      break;
      case 3:
      content += " Tuesday, ";
      break;
      case 4:
      content += " Wednesday, ";
      break;
      case 5:
      content += " Thursday, ";
      break;
      case 6:
      content += " Friday, ";
      break;
      case 7:
      content += " Saturday, ";
      break;
      }     
      content += " - Reload this page to refresh clock<p>";  
        
      content += "<fieldset>";
      content += "<legend><b>Network</b></legend>";
      if(Login_Successful)
      {
        content += "The device successfully logged on to ";
        content += esid + "<br>"; 
        if (WiFi.status() == WL_CONNECTED)       
        {
          content += "The device connection is good <p>"; 
        }
        else
        content += " <b><i>The device lost its connection after login </b></i>";       
      }
      else content += " <b><i>WARNING! The device was not able to log in to the network </b></i>"; 
      content += "<p> <input type = 'submit' formaction = 'setting15' value = 'WiFi'>"; 
      content += "</fieldset>";

      content += "<fieldset>";
      content += "<legend><b>Output Relays</b></legend>";
      content += "<p> <input type = 'submit' formaction = 'setting9'";
      content += "value = 'Alexa Voice Control'> Settings for voice control ";  
      content += "<p> <input type = 'submit' formaction = 'setting16'";
      content += "value = 'Relay ON timers'> ON time of each relay after being switched";
      content += "<p> <input type = 'submit' formaction = 'setting17' value = 'Automatic Timer Control'>";
      content += " Relay 1 (" + Relay_Descriptors[0] + ")" ;     
      if (No_Of_Relays >=2)
      {
        content += "<p> <input type = 'submit' formaction = 'setting18' value = 'Automatic Timer Control'>";
        content += " Relay 2 (" + Relay_Descriptors[1] + ")" ;
      }
      if (No_Of_Relays == 3) 
      {
        content += "<p> <input type = 'submit' formaction = 'setting19' value = 'Automatic Timer Control'>";
        content += " Relay 3 (" + Relay_Descriptors[2] + ")" ;           
      }
      content += "</fieldset>";  
                  
      if (No_Of_AUX  > 0) 
      {
      content += "<fieldset>";
      content += "<legend><b>Auxiliary inputs</b></legend>";        
      content += "<p><input type = 'submit' formaction = 'setting10' value = 'AUX'> Mode and Timer Setup<p> ";  
      content += "</fieldset>";             
      }          
      
      content += "<fieldset>";   
      content += "<legend><b>Manual Control of Relay Outputs</b></legend>";        
      content += "<p> <input type = 'submit' formaction = 'setting6' ";
      if(digitalRead(Relay_Pin[0]) == Relay_On) content += "value = ' Relay 1 is ON'>"; else content += "value = 'Relay 1 is OFF'>";
      content += " Toggle Relay ON & OFF<br>";      
      if (No_Of_Relays >= 2)   // if 2 or 3 relays fitted
      {
        content += "<p> <input type = 'submit' formaction = 'setting7' ";           
        if(digitalRead(Relay_Pin[1]) == Relay_On) content += "value = 'Relay 2 is ON'>"; else content += "value = 'Relay 2 is OFF'>";
        content += " Toggle Relay ON & OFF<br>";
      }      
      if (No_Of_Relays ==3)  // if 3 relays fitted
      {
        content += "<p> <input type = 'submit' formaction = 'setting8' ";      
        if(digitalRead(Relay_Pin[2]) == Relay_On) content += "value = 'Relay 3 is ON'>"; else content += "value = 'Relay 3 is OFF'>";
        content += " Toggle Relay ON & OFF<br>"; 
      }
      content += "</fieldset>"; 
      
      content += "<p> <input type = 'submit' formaction = 'setting20' value = 'Device Reset'> ";  
      content += "<p> <input type = 'submit' formaction = 'setting22' value = 'System Status & Master Clock'> ";   
            
      if (Soft_AP_Switch) content += "<p> <input type = 'submit' formaction = 'setting21' value = 'Switch Off Access Point (AP will close afterwards)'> ";                
      content += "</form></html>";  
      Heartbeat_Tick();   // Feed the HW watchdog!         
      serverAP.send(200, "text/html", content);      
    });    
    // ------------------------   SETTING -----------------------------
    serverAP.on("/setting", []()  // Wifi Configuration page
    {
        String qsid = serverAP.arg("ssid");   // check input from web page when submitted
        String qpass = serverAP.arg("pass");
        String qname = serverAP.arg("name");
 
       // .................. Process Network SSID  .................................       
          if (qsid.length() > 0 ) // Only if something has been entered into the SSID web field
          {
            unsigned int i=EEPROM_WiFi_SSID;
            while(i < EEPROM_WiFi_SSID + Max_String_Length)  // Clear out all of the previous stored entries for SSID
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qsid.length())   // store new SSID to EEPROM
            {
              EEPROM.write(EEPROM_WiFi_SSID + i, qsid[i]);
              i++;
            }
          } // end of if (qsid.length() > 0 ) // Only if something has been entered into the SSID web field
            
       // .................. Process Network password  .................................          
          if (qpass.length() > 0) // Only if something has been entered into the Password web field
          {    
            unsigned int i = EEPROM_WiFi_Password;
            while(i < (EEPROM_WiFi_Password + Max_String_Length))
            {
              EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
              i++;
            }         
            i = 0; 
            while(i < qpass.length())  // store new password to EEPROM
            {
              EEPROM.write(EEPROM_WiFi_Password + i, qpass[i]);
              i++;
            }           
          } // end of if (qpass.length() > 0) // Only if something has been entered into the Password web field
                         
       // ................... Process Device Name ..................................          
          if (qname.length() > 0) // Only if something has been entered into the Device name web field
          {    
            unsigned int i = EEPROM_HostName;
            while(i < (EEPROM_HostName + Max_String_Length))
            {
              EEPROM.write(i, 255); // Clear out all of the previous stored entries for password
              i++;
            }         
            i = 0; 
            while(i < qname.length())  // store new device name to EEPROM
            {
              EEPROM.write(EEPROM_HostName + i, qname[i]);
              i++;
            }
          }  // end of if (qname.length() > 0) // Only if something has been entered into the Device name web field
            
          EEPROM.commit();   // Lock in EEPROM changes
          Download_From_EEPROM_Output_And_Input_Settings(false);                                
          Success_Message(false);  // Upload success message to client to AP web page 
          Heartbeat_Tick();   // Feed the HW watchdog!          
 // -----------------------------------------------------------------------------------------------
    });   // end of serverAP.on("/setting", []() 

 // ------------------------- SETTING 2 -------------------------------------
  serverAP.on("/setting2", []()   // Relay 1 Timer control configuration page
  {
    String qRelay1_Timer1_Sun = serverAP.arg("Relay1_Timer1_Sunday");
    String qRelay1_Timer1_Mon = serverAP.arg("Relay1_Timer1_Monday");   
    String qRelay1_Timer1_Tue = serverAP.arg("Relay1_Timer1_Tuesday");
    String qRelay1_Timer1_Wed = serverAP.arg("Relay1_Timer1_Wednesday");   
    String qRelay1_Timer1_Thu = serverAP.arg("Relay1_Timer1_Thursday");
    String qRelay1_Timer1_Fri = serverAP.arg("Relay1_Timer1_Friday");   
    String qRelay1_Timer1_Sat = serverAP.arg("Relay1_Timer1_Saturday");  

    String qRelay1_Timer2_Sun = serverAP.arg("Relay1_Timer2_Sunday");
    String qRelay1_Timer2_Mon = serverAP.arg("Relay1_Timer2_Monday");   
    String qRelay1_Timer2_Tue = serverAP.arg("Relay1_Timer2_Tuesday");
    String qRelay1_Timer2_Wed = serverAP.arg("Relay1_Timer2_Wednesday");   
    String qRelay1_Timer2_Thu = serverAP.arg("Relay1_Timer2_Thursday");
    String qRelay1_Timer2_Fri = serverAP.arg("Relay1_Timer2_Friday");   
    String qRelay1_Timer2_Sat = serverAP.arg("Relay1_Timer2_Saturday");
      
    String qRelay1_TIM_1_ON = serverAP.arg("Relay1_Timer_1_ON"); 
    String qRelay1_TIM_1_OFF = serverAP.arg("Relay1_Timer_1_OFF");
    String qRelay1_TIM_2_ON = serverAP.arg("Relay1_Timer_2_ON");
    String qRelay1_TIM_2_OFF = serverAP.arg("Relay1_Timer_2_OFF");   
    String qRelay1_Mode = serverAP.arg("Relay1_Mode");
   
    content = "<!DOCTYPE HTML> \r\n<html>";

    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_1_ON)); 
    EEPROM.write(EEPROM_Relay1_Timer1_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_1_ON));         
    EEPROM.write(EEPROM_Relay1_Timer1_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_1_OFF)); 
    EEPROM.write(EEPROM_Relay1_Timer1_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_1_OFF)); 

    content += "<br><br>Relay 1 Timer 1 days";           
    if (qRelay1_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay1_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Sun,false);
    
    if (qRelay1_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay1_Timer1_Mon,true); 
    else EEPROM.write(EEPROM_Relay1_Timer1_Mon,false);
        
    if (qRelay1_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay1_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Tue,false);
       
    if (qRelay1_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay1_Timer1_Wed,true);      
    else EEPROM.write(EEPROM_Relay1_Timer1_Wed,false);

    if (qRelay1_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay1_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Thu,false);       
    
    if (qRelay1_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay1_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay1_Timer1_Fri,false);   
    
    if (qRelay1_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay1_Timer1_Sat,true);                   
    else EEPROM.write(EEPROM_Relay1_Timer1_Sat,false);    
    
    // TIMER 2   
    EEPROM.write(EEPROM_Relay1_Timer2_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay1_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay1_Timer2_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay1_TIM_2_OFF)); 
    EEPROM.write(EEPROM_Relay1_Timer2_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay1_TIM_2_OFF));    
           
    if (qRelay1_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay1_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay1_Timer2_Sun,false);    
        
    if (qRelay1_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay1_Timer2_Mon,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Mon,false);     
       
    if (qRelay1_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay1_Timer2_Tue,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Tue,false);     
        
    if (qRelay1_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay1_Timer2_Wed,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Wed,false);     
        
    if (qRelay1_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay1_Timer2_Thu,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Thu,false);     
    
    if (qRelay1_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay1_Timer2_Fri,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Fri,false);    
    
    if (qRelay1_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay1_Timer2_Sat,true);      
    else EEPROM.write(EEPROM_Relay1_Timer2_Sat,false);
        
    if (qRelay1_Mode == "0") EEPROM.write(EEPROM_Timer_Enable_Relay1,false); 
    if (qRelay1_Mode == "1") EEPROM.write(EEPROM_Timer_Enable_Relay1,true);       
    
    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);   
    Success_Message(false);  // Upload success message to AP web page
    Heartbeat_Tick();   // Feed the HW watchdog! 
 // ----------------------------------------------------------------------------------------------- 
 });    // end of   serverAP.on("/setting2", []()   // Timer control configuration page

// ----------------------------  SETTING 3 ------------------------  
    serverAP.on("/setting3", []() // Output ON timers
    {       
        String qSwitch_Timer1 = serverAP.arg("Switch_Timer1");
        String qSwitch_Timer2 = serverAP.arg("Switch_Timer2");
        String qSwitch_Timer3 = serverAP.arg("Switch_Timer3");    
      // .................... Process Output Timer1 ................................ 
      if (qSwitch_Timer1.length() > 0) // Only if something has been entered into the Output timer 1 web field
      {    
         byte Value = 0;
         byte i = 0; 
         boolean Status = false;
                   // validate and convert web entry to a decimal number for storage
         if (qSwitch_Timer1.length() == 1);  // 1 digit entered
         {
           if(isDigit (qSwitch_Timer1[0]))  // only if digit is numerical 
           {
             Value = qSwitch_Timer1[0] - '0'; 
             Status = true;
           }
         } // end of if (qSwitch_Timer1.length() == 1);  // 1 digit entered
            
         if (qSwitch_Timer1.length() == 2);   // 2 digits entered
         {
           if(isDigit (qSwitch_Timer1[0]) && isDigit (qSwitch_Timer1[1]))  // only if digits are numerical 
           {
             Value = (qSwitch_Timer1[1] - '0') + ((qSwitch_Timer1[0] - '0') * 10); 
             Status = true;
           }
         } // end of if (qSwitch_Timer1.length() == 2);   // 2 digits entered
           
         if (qSwitch_Timer1.length() == 3);   // 3 digits entered
         {                      
           if(isDigit (qSwitch_Timer1[0]) && isDigit (qSwitch_Timer1[1]) && isDigit (qSwitch_Timer1[2]))
           {           // only if digits are numerical
             Value = (qSwitch_Timer1[2] - '0') + ((qSwitch_Timer1[1] - '0') * 10) + ((qSwitch_Timer1[0] - '0') * 100) ; 
             Status = true;                
           }
         } // end of  if (qSwitch_Timer1.length() == 3);   // 3 digits entered                    
         if (Status) EEPROM.write(EEPROM_Relay_On_Time_Parameter, Value);     // if valid entry made
     } // end of if (qSwitch_Timer1.length() > 0) // Only if something has been entered into the Device name web field
         
      // .......................... Process Output Timer 2 .......................... 
     if (qSwitch_Timer2.length() > 0) // Only if something has been entered into the Output timer 2 web field
     {    
       byte Value = 0;
       byte i = 0; 
       boolean Status = false;
                   // validate and convert web entry to a decimal number for storage
       if (qSwitch_Timer2.length() == 1);  // 1 digit entered
       {
         if(isDigit (qSwitch_Timer2[0]))  // only if digit is numerical 
         {
           Value = qSwitch_Timer2[0] - '0'; 
           Status = true;
         }
       }  // end of if (qSwitch_Timer2.length() == 1);  // 1 digit entered
            
       if (qSwitch_Timer2.length() == 2);   // 2 digits entered
       {
         if(isDigit (qSwitch_Timer2[0]) && isDigit (qSwitch_Timer2[1]))  // only if digits are numerical 
         {
           Value = (qSwitch_Timer2[1] - '0') + ((qSwitch_Timer2[0] - '0') * 10); 
           Status = true;
         }
       }  // end of if (qSwitch_Timer2.length() == 2);   // 2 digits entered
            
       if (qSwitch_Timer2.length() == 3);   // 3 digits entered
       {                     
         if(isDigit (qSwitch_Timer2[0]) && isDigit (qSwitch_Timer2[1]) && isDigit (qSwitch_Timer2[2]))
         {           // only if digits are numerical 
           Value = (qSwitch_Timer2[2] - '0') + ((qSwitch_Timer2[1] - '0') * 10) + ((qSwitch_Timer2[0] - '0') * 100) ; 
           Status = true;                
         }              
       }  // end of if (qSwitch_Timer2.length() == 3);   // 3 digits entered         
            
       if (Status)  EEPROM.write(EEPROM_Relay_On_Time_Parameter + 1, Value);       // if valid entry made
    } // end of if (qSwitch_Timer2.length() > 0) // Only if something has been entered into the Device name web field
         
      // ........................ Process Output Timer 3 ................................... 
    if (qSwitch_Timer3.length() > 0) // Only if something has been entered into the output timer 3 web field
    {    
      byte Value = 0;
      byte i = 0; 
      boolean Status = false;
                 // validate and convert web entry to a decimal number for storage
      if (qSwitch_Timer3.length() == 1);  // 1 digit entered
      {
        if(isDigit (qSwitch_Timer3[0]))  // only if digit is numerical 
        {
          Value = qSwitch_Timer3[0] - '0'; 
          Status = true;
        }
      } // end of if (qSwitch_Timer3.length() == 1);  // 1 digit entered
            
      if (qSwitch_Timer3.length() == 2);   // 2 digits entered
      {
        if(isDigit (qSwitch_Timer3[0]) && isDigit (qSwitch_Timer3[1]))  
        {         // only if digits are numerical 
          Value = (qSwitch_Timer3[1] - '0') + ((qSwitch_Timer3[0] - '0') * 10); 
          Status = true;
        }           
      }  // end of if (qSwitch_Timer3.length() == 2);   // 2 digits entered
            
      if (qSwitch_Timer3.length() == 3);   // 3 digits entered
      {                     // only if digits are numerical 
        if(isDigit (qSwitch_Timer3[0]) && isDigit (qSwitch_Timer3[1]) && isDigit (qSwitch_Timer3[2]))
        {
          Value = (qSwitch_Timer3[2] - '0') + ((qSwitch_Timer3[1] - '0') * 10) + ((qSwitch_Timer3[0] - '0') * 100) ; 
          Status = true;                
        }              
      }    // end of if (qSwitch_Timer3.length() == 3);   // 3 digits entered        
            
      if (Status)  EEPROM.write(EEPROM_Relay_On_Time_Parameter + 2, Value);   // if valid entry made
   } // end of if (qSwitch_Timer3.length() > 0) // Only if something has been entered into the Device name web field
         
      
   EEPROM.commit();   // Lock in EEPROM changes
   Download_From_EEPROM_Output_And_Input_Settings(false);                               
   Success_Message(false);  // Upload success message to client 
   Heartbeat_Tick();   // Feed the HW watchdog!        
 });   // end of serverAP.on("/setting3", []() 
        
// ------------------------- SETTING 4 -------------------------------------
  serverAP.on("/setting4", []()   // Relay 2 Timer control configuration page
  {
    String qRelay2_Timer1_Sun = serverAP.arg("Relay2_Timer1_Sunday");
    String qRelay2_Timer1_Mon = serverAP.arg("Relay2_Timer1_Monday");   
    String qRelay2_Timer1_Tue = serverAP.arg("Relay2_Timer1_Tuesday");
    String qRelay2_Timer1_Wed = serverAP.arg("Relay2_Timer1_Wednesday");   
    String qRelay2_Timer1_Thu = serverAP.arg("Relay2_Timer1_Thursday");
    String qRelay2_Timer1_Fri = serverAP.arg("Relay2_Timer1_Friday");   
    String qRelay2_Timer1_Sat = serverAP.arg("Relay2_Timer1_Saturday");  

    String qRelay2_Timer2_Sun = serverAP.arg("Relay2_Timer2_Sunday");
    String qRelay2_Timer2_Mon = serverAP.arg("Relay2_Timer2_Monday");   
    String qRelay2_Timer2_Tue = serverAP.arg("Relay2_Timer2_Tuesday");
    String qRelay2_Timer2_Wed = serverAP.arg("Relay2_Timer2_Wednesday");   
    String qRelay2_Timer2_Thu = serverAP.arg("Relay2_Timer2_Thursday");
    String qRelay2_Timer2_Fri = serverAP.arg("Relay2_Timer2_Friday");   
    String qRelay2_Timer2_Sat = serverAP.arg("Relay2_Timer2_Saturday");
      
    String qRelay2_TIM_1_ON = serverAP.arg("Relay2_Timer_1_ON"); 
    String qRelay2_TIM_1_OFF = serverAP.arg("Relay2_Timer_1_OFF");
    String qRelay2_TIM_2_ON = serverAP.arg("Relay2_Timer_2_ON");
    String qRelay2_TIM_2_OFF = serverAP.arg("Relay2_Timer_2_OFF"); 
    String qRelay2_Mode = serverAP.arg("Relay2_Mode");  
    
    content = "<!DOCTYPE HTML> \r\n<html>";

    EEPROM.write(EEPROM_Relay2_Timer1_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_1_ON)); 
    EEPROM.write(EEPROM_Relay2_Timer1_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_1_ON));   
    EEPROM.write(EEPROM_Relay2_Timer1_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_1_OFF)); 
    EEPROM.write(EEPROM_Relay2_Timer1_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_1_OFF));  

    if (qRelay2_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay2_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Sun,false);
    
    if (qRelay2_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay2_Timer1_Mon,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Mon,false);
    
    if (qRelay2_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay2_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Tue,false);
  
    if (qRelay2_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay2_Timer1_Wed,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Wed,false);
    
    if (qRelay2_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay2_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Thu,false);
    
    if (qRelay2_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay2_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Fri,false);
    
    if (qRelay2_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay2_Timer1_Sat,true);
    else EEPROM.write(EEPROM_Relay2_Timer1_Sat,false);
   
    // TIMER 2
    EEPROM.write(EEPROM_Relay2_Timer2_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay2_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_2_ON));  
    EEPROM.write(EEPROM_Relay2_Timer2_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay2_TIM_2_OFF)); 
    EEPROM.write(EEPROM_Relay2_Timer2_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay2_TIM_2_OFF));  
    
    if (qRelay2_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay2_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Sun,false);
    
    if (qRelay2_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay2_Timer2_Mon,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Mon,false);

    if (qRelay2_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay2_Timer2_Tue,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Tue,false);

    if (qRelay2_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay2_Timer2_Wed,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Wed,false);

    if (qRelay2_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay2_Timer2_Thu,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Thu,false);

    if (qRelay2_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay2_Timer2_Fri,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Fri,false);

    if (qRelay2_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay2_Timer2_Sat,true);
    else EEPROM.write(EEPROM_Relay2_Timer2_Sat,false);
      
    if (qRelay2_Mode == "0") EEPROM.write(EEPROM_Timer_Enable_Relay2,false);  
    if (qRelay2_Mode == "1") EEPROM.write(EEPROM_Timer_Enable_Relay2,true);

    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);
    Success_Message(false);  // Upload success message to AP web page
    Heartbeat_Tick();   // Feed the HW watchdog!       
 });    // end of   serverAP.on("/setting4", []()   // Timer control configuration page

// ------------------------- SETTING 5 -------------------------------------
  serverAP.on("/setting5", []()   // Relay 3 Timer control configuration page
  {
    String qRelay3_Timer1_Sun = serverAP.arg("Relay3_Timer1_Sunday");
    String qRelay3_Timer1_Mon = serverAP.arg("Relay3_Timer1_Monday");   
    String qRelay3_Timer1_Tue = serverAP.arg("Relay3_Timer1_Tuesday");
    String qRelay3_Timer1_Wed = serverAP.arg("Relay3_Timer1_Wednesday");   
    String qRelay3_Timer1_Thu = serverAP.arg("Relay3_Timer1_Thursday");
    String qRelay3_Timer1_Fri = serverAP.arg("Relay3_Timer1_Friday");   
    String qRelay3_Timer1_Sat = serverAP.arg("Relay3_Timer1_Saturday");  

    String qRelay3_Timer2_Sun = serverAP.arg("Relay3_Timer2_Sunday");
    String qRelay3_Timer2_Mon = serverAP.arg("Relay3_Timer2_Monday");   
    String qRelay3_Timer2_Tue = serverAP.arg("Relay3_Timer2_Tuesday");
    String qRelay3_Timer2_Wed = serverAP.arg("Relay3_Timer2_Wednesday");   
    String qRelay3_Timer2_Thu = serverAP.arg("Relay3_Timer2_Thursday");
    String qRelay3_Timer2_Fri = serverAP.arg("Relay3_Timer2_Friday");   
    String qRelay3_Timer2_Sat = serverAP.arg("Relay3_Timer2_Saturday");
      
    String qRelay3_TIM_1_ON = serverAP.arg("Relay3_Timer_1_ON"); 
    String qRelay3_TIM_1_OFF = serverAP.arg("Relay3_Timer_1_OFF");
    String qRelay3_TIM_2_ON = serverAP.arg("Relay3_Timer_2_ON");
    String qRelay3_TIM_2_OFF = serverAP.arg("Relay3_Timer_2_OFF");   

    String qRelay3_Mode = serverAP.arg("Relay3_Mode");
    
    content = "<!DOCTYPE HTML> \r\n<html>";

    EEPROM.write(EEPROM_Relay3_Timer1_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_1_ON)); 
    EEPROM.write(EEPROM_Relay3_Timer1_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_1_ON));
    EEPROM.write(EEPROM_Relay3_Timer1_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_1_OFF)); 
    EEPROM.write(EEPROM_Relay3_Timer1_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_1_OFF)); 
       
    if (qRelay3_Timer1_Sun == "1") EEPROM.write(EEPROM_Relay3_Timer1_Sun,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Sun,false);
    
    if (qRelay3_Timer1_Mon == "2") EEPROM.write(EEPROM_Relay3_Timer1_Mon,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Mon,false);
    
    if (qRelay3_Timer1_Tue == "3") EEPROM.write(EEPROM_Relay3_Timer1_Tue,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Tue,false);
    
    if (qRelay3_Timer1_Wed == "4") EEPROM.write(EEPROM_Relay3_Timer1_Wed,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Wed,false);
    
    if (qRelay3_Timer1_Thu == "5") EEPROM.write(EEPROM_Relay3_Timer1_Thu,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Thu,false);
    
    if (qRelay3_Timer1_Fri == "6") EEPROM.write(EEPROM_Relay3_Timer1_Fri,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Fri,false);
    
    if (qRelay3_Timer1_Sat == "7") EEPROM.write(EEPROM_Relay3_Timer1_Sat,true);
    else EEPROM.write(EEPROM_Relay3_Timer1_Sat,false);

    // TIMER 2    
    EEPROM.write(EEPROM_Relay3_Timer2_TimOn_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay3_Timer2_TimOn_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_2_ON)); 
    EEPROM.write(EEPROM_Relay3_Timer2_TimOff_Min, Get_Decimal_Mins_From_Web_Time_Value(qRelay3_TIM_2_OFF)); 
    EEPROM.write(EEPROM_Relay3_Timer2_TimOff_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qRelay3_TIM_2_OFF)); 
     
    if (qRelay3_Timer2_Sun == "1") EEPROM.write(EEPROM_Relay3_Timer2_Sun,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Sun,false);
    
    if (qRelay3_Timer2_Mon == "2") EEPROM.write(EEPROM_Relay3_Timer2_Mon,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Mon,false);
    
    if (qRelay3_Timer2_Tue == "3") EEPROM.write(EEPROM_Relay3_Timer2_Tue,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Tue,false);
    
    if (qRelay3_Timer2_Wed == "4") EEPROM.write(EEPROM_Relay3_Timer2_Wed,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Wed,false);
    
    if (qRelay3_Timer2_Thu == "5") EEPROM.write(EEPROM_Relay3_Timer2_Thu,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Thu,false);
    
    if (qRelay3_Timer2_Fri == "6") EEPROM.write(EEPROM_Relay3_Timer2_Fri,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Fri,false);
    
    if (qRelay3_Timer2_Sat == "7") EEPROM.write(EEPROM_Relay3_Timer2_Sat,true);
    else EEPROM.write(EEPROM_Relay3_Timer2_Sat,false);
    
    if (qRelay3_Mode == "0") EEPROM.write(EEPROM_Timer_Enable_Relay3,false); 
    if (qRelay3_Mode == "1") EEPROM.write(EEPROM_Timer_Enable_Relay3,true);       
    
    EEPROM.commit();
    Download_From_EEPROM_Timer_Control_Parameters(false);   
    Success_Message(false);  // Upload success message to AP Web page 
    Heartbeat_Tick();   // Feed the HW watchdog!      
 });    // end of   serverAP.on("/setting5", []()   // Timer control configuration page
  // -------------------------------------------------------------------------------------------
 serverAP.on("/setting6", []()    // Manual switching of relay 1
 { 
   content = "<!DOCTYPE HTML> \r\n<html>";     
     
   if(digitalRead(Relay_Pin[0]) == Relay_Off) 
   {
     content += "<br>Relay 1 (";
     content += Relay_Descriptors[0] + ") switched ON";   
     Activate_Relay(0, Relay_On, true);     
   }
   else
   {
     content += "<br>Relay 1 (";
     content += Relay_Descriptors[0] + ") switched Off";   
     Activate_Relay(0, Relay_Off, true);     
   }
   content += "<p><br><br><a href='http://192.168.8.200'> Return to main configuration menu page  </a>";            
   serverAP.send(200, "text/html", content); 
    });   // end of serverAP.on("/setting6", []()   
  // ---------------------------------------------------------------------
serverAP.on("/setting7", []()    // Manual switching of relay 2
 { 
   content = "<!DOCTYPE HTML> \r\n<html>";     
     
   if(digitalRead(Relay_Pin[1]) == Relay_Off) 
   {
     content += "<br>Relay 2 (";
     content += Relay_Descriptors[1] + ") switched ON";   
     Activate_Relay(1, Relay_On,true);     
   }
   else
   {
     content += "<br>Relay 2 (";
     content += Relay_Descriptors[1] + ") switched Off";   
     Activate_Relay(1, Relay_Off,true);     
   }
   content += "<p><br><br><a href='http://192.168.8.200'> Return to main configuration menu page  </a>";            
   serverAP.send(200, "text/html", content); 
   Heartbeat_Tick();   // Feed the HW watchdog! 
    });   // end of serverAP.on("/setting7", []()  
  // -----------------------------------------------------------------------
 serverAP.on("/setting8", []()    // Manual switching of relay 3
 { 
   content = "<!DOCTYPE HTML> \r\n<html>";     
     
   if(digitalRead(Relay_Pin[2]) == Relay_Off) 
   {
     content += "<br>Relay 3 (";
     content += Relay_Descriptors[2] + ") switched ON";   
     Activate_Relay(2, Relay_On,true);     
   }
   else
   {
     content += "<br>Relay 3 (";
     content += Relay_Descriptors[2] + ") switched Off";   
     Activate_Relay(2, Relay_Off,true);     
   }
   content += "<p><br><br><a href='http://192.168.8.200'> Return to main configuration menu page  </a>";            
   serverAP.send(200, "text/html", content); 
   Heartbeat_Tick();   // Feed the HW watchdog!
    });   // end of serverAP.on("/setting8", []()   
  // -----------------------------------------------------------------------
 serverAP.on("/setting9", []()    // Names for Alexa voice control
 {
    content = "<!DOCTYPE HTML>\r\n<html>";
    content += "<h3>Alexa Voice Control Settings (Device will automatically reset after uploading data)</h3>";
    content += "<p><form action='setting13' autocomplete = 'off' ></p>";
    
    content += "<fieldset>";
    content += "<legend><b> Output Relay Names</b> </legend>";
    content += "<label>Relay 1 name (Max 20 char) </label>  <input name='Alexa1' value = ";
    content += Relay_Descriptors[0];
    content += " size = '20' length=20>"; 
    content += "<br><input type = 'checkbox' name = 'Alexa_Enable1'  value = '1' ";
    if (Alexa_Enable[0]) content += " checked"; 
    content += ">Relay 1 Alexa Enabled";
       
    
    if (No_Of_Relays >= 2)
    {
      content += "<p><label>Relay 2 name (Max 20 char) </label>  <input name='Alexa2' value = ";
      content += Relay_Descriptors[1];
      content += " size = '20' length=20>";
      content += "<br><input type = 'checkbox' name = 'Alexa_Enable2'  value = '1' ";
      if (Alexa_Enable[1]) content += " checked";
      content += "> Relay 2 Alexa Enabled";      
    } 
    if (No_Of_Relays == 3)
    {
      content += "<p><label>Relay 3 name (Max 20 char) </label>  <input name='Alexa3' value = ";
      content += Relay_Descriptors[2];
      content += " size = '20' length=20>"; 
      content += "<br><input type = 'checkbox' name = 'Alexa_Enable3'  value = '1' ";
      if (Alexa_Enable[2]) content += " checked";
      content += "> Relay 3 Alexa Enabled";       
    } 
    content += "</fieldset>" ;      
       
    content += "<p><input type='submit' value = 'Upload new settings'> ' NOTE: <b>Device will reset after uploading' </form>";
    content += "<p><a href='http://192.168.8.200'> Return to the main menu page (without saving any new data)</a>";
    content += "</html>";
    serverAP.send(200, "text/html", content);
    Heartbeat_Tick();   // Feed the HW watchdog! 
 });   // end of serverAP.on("/setting9", []() 
  // -----------------------------------------------------------------------
 serverAP.on("/setting10", []()    // AUX input setup
 {
    content = "<!DOCTYPE HTML>\r\n<html>";
    content += "<form action='setting14'>";
    
    content += "<fieldset>"; 
    content += "<legend><b>Auxiliary Input Mode</b></legend>"; 
    content += "<br><input type = 'radio' name = 'AUX1_Mode' value = '0'";
    if(AUX_Mode[0] == 0) content += "checked";
    content+= ">AUX 1 disabled";
    content += "<br><input type = 'radio' name = 'AUX1_Mode' value = '1'";
    if (AUX_Mode[0] == 1) content += "checked";
    content += ">PIR movement sensor for Relay 1";
    content += "<br><input type = 'radio' name = 'AUX1_Mode' value = '3'";    
    if (AUX_Mode[0] == 3) content += "checked";
    content += ">Manual ON/OFF switch input for Relay 1";     
    
    if(No_Of_AUX >= 2) 
    {
        content += "<p><input type = 'radio' name = 'AUX2_Mode' value = '0'";
        if(AUX_Mode[1] == 0) content += "checked";       
        content += ">AUX 2 disabled";
        content += "<br><input type = 'radio' name = 'AUX2_Mode' value = '1'";
        if(AUX_Mode[1] == 1) content += "checked";        
        content+= ">PIR movement sensor for Relay 2"; 
        content += "<br><input type = 'radio' name = 'AUX2_Mode' value = '3'";    
        if (AUX_Mode[1] == 3) content += "checked";
        content += ">Manual ON/OFF switch input for Relay 2";         
        content += "<br><input type = 'radio' name = 'AUX2_Mode' value = '2'";   
        if (AUX_Mode[1] == 2) content += "checked";
        content += ">Pump Protection Input Sensor for Relay 1";        
    }
    if(No_Of_AUX == 3) 
    {
        content += "<p><input type = 'radio' name = 'AUX3_Mode' value = '0'";
        if(AUX_Mode[2] == 0) content += "checked";       
        content += ">AUX 3 disabled";
        content += "<br><input type = 'radio' name = 'AUX3_Mode' value = '1'";
        if(AUX_Mode[2] == 1) content += "checked";        
        content+= ">PIR movement sensor for Relay 3"; 
        content += "<br><input type = 'radio' name = 'AUX3_Mode' value = '3'";    
        if (AUX_Mode[2] == 3) content += "checked";
        content += ">Manual ON/OFF switch input for Relay 3";     
               
    }   
    content += "</fieldset>";

    content += "<fieldset>"; 
    content += "<legend><b>PIR ON time when movement detected</b></legend>";     
    content += "<br><label>Timer (1-240 mins): <input type = 'number' name='PIR_Time' value = " + String(PIR_Time) + " size = '3' min='1' max = '240'>";             
    content += "</fieldset>"; 
    
    content += "<fieldset>"; 
    content += "<legend><b>Pump Protection Timers (Relay 1 only)</b></legend>";     
    content += "<br><label>Start up delay (1-90 seconds) before pump protection monitoring starts: <input type = 'number' name='Start_Up_Delay' "; 
    byte variable = EEPROM.read(EEPROM_Pump_Protection_Start_Up_Delay_Time);
    content += "value = " + String(variable) + " size = '3' min='1' max = '90'>"; 
    content += "<br><label>May allowed detected dry run time (1-10 seconds) before pump shut off: <input type = 'number' name='Dry_Time_Delay' "; 
    variable = EEPROM.read(EEPROM_Pump_Protection_Dry_Time);
    content += "value = " + String(variable) + " size = '1' min='1' max = '10'>";                
    content += "</fieldset>"; 
  
    content += "<p><input type='submit' value = 'Upload new settings to the device'>"; 
    content += "</form>";
    
    content += "<p><a href='http://192.168.8.200'> Return to the Main Configuration Menu page </a>";
    content += "</html>";
    serverAP.send(200, "text/html", content);
    Heartbeat_Tick();   // Feed the HW watchdog! 
 });   // end of serverAP.on("/setting10", []() 
  // -----------------------------------------------------------------------
 serverAP.on("/setting13", []()    // Process Alexa text names
 {
        String qAlexa1 = serverAP.arg("Alexa1");   // check input from web page when submitted
        String qAlexa2 = serverAP.arg("Alexa2");   
        String qAlexa3 = serverAP.arg("Alexa3");   
        String qAlexa4 = serverAP.arg("Alexa4");
        String qAlexa_Enable1 = serverAP.arg("Alexa_Enable1");
        String qAlexa_Enable2 = serverAP.arg("Alexa_Enable2");        
        String qAlexa_Enable3 = serverAP.arg("Alexa_Enable3");        
       // .................. Process Alexa Name 1  .................................       
          if (qAlexa1.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors;
            while(i < EEPROM_Relay_Descriptors + Max_String_Length)  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qAlexa1.length())   // store new Alexa name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + i, qAlexa1[i]);
              i++;
            }
          } // end of if (qAlexa1.length() > 0 ) // Only if something has been entered into the field  
 
        // .................. Process Alexa Name 2  .................................       
          if (qAlexa2.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors + Max_String_Length;
            while(i < EEPROM_Relay_Descriptors + (2*Max_String_Length))  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qAlexa2.length())   // store new Alexa name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + Max_String_Length + i, qAlexa2[i]);
              i++;
            }
          } // end of if (qAlexa2.length() > 0 ) // Only if something has been entered into the field    

       // .................. Process Alexa Name 3  .................................       
          if (qAlexa3.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors + (2*Max_String_Length);
            while(i < EEPROM_Relay_Descriptors + (3*Max_String_Length))  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qAlexa3.length())   // store new Alexa name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + (2*Max_String_Length) + i, qAlexa3[i]);
              i++;
            }
          } // end of if (qAlexa2.length() > 0 ) // Only if something has been entered into the field    

 // .................. Process Alexa Name 4  .................................       
          if (qAlexa4.length() > 0 ) // Only if something has been entered into the web field
          {
            unsigned int i=EEPROM_Relay_Descriptors + (3*Max_String_Length);
            while(i < EEPROM_Relay_Descriptors + (4*Max_String_Length))  // Clear out all of the previous stored entries 
            {
              EEPROM.write(i, 255);
              i++;
            }
            i=0;
            while(i < qAlexa4.length())   // store new Alexa name to EEPROM
            {
              EEPROM.write(EEPROM_Relay_Descriptors + (3*Max_String_Length) + i, qAlexa4[i]);
              i++;
            }
          } // end of if (qAlexa4.length() > 0 ) // Only if something has been entered into the field  
    if(qAlexa_Enable1 == "1") EEPROM.write(EEPROM_Alexa_Enable1, true);
    else EEPROM.write(EEPROM_Alexa_Enable1, false); 
    if(qAlexa_Enable2 == "1") EEPROM.write(EEPROM_Alexa_Enable2, true);
    else EEPROM.write(EEPROM_Alexa_Enable2, false);
    if(qAlexa_Enable3 == "1") EEPROM.write(EEPROM_Alexa_Enable3, true);
    else EEPROM.write(EEPROM_Alexa_Enable3, false);       
    EEPROM.commit();  // lock in the EEPROM
    Success_Message(true);  // Upload success message to client to AP web page  & reset device 
 });   // end of serverAP.on("/setting13", []() 
              // ..................... Process PIR Timer ................. 
 serverAP.on("/setting14", []()    // Process AUX settings
 {
    String qAUX1_Mode = serverAP.arg("AUX1_Mode");
    String qAUX2_Mode = serverAP.arg("AUX2_Mode"); 
    String qAUX3_Mode = serverAP.arg("AUX3_Mode");          
    String qPIR_Time = serverAP.arg("PIR_Time");
    String qStart_Up_Delay = serverAP.arg("Start_Up_Delay");
    String qDry_Time_Delay = serverAP.arg("Dry_Time_Delay");

    byte Value = 0;
    byte i = 0; 
    boolean Status = false;
            // validate and convert web entry to a decimal number for storage
    if (qPIR_Time.length() == 1);  // 1 digit entered
    {
      if(isDigit (qPIR_Time[0]))  // only if digit is numerical 
      {
        Value = qPIR_Time[0] - '0'; 
        Status = true;
      }
    } // end of if (qPIR_Time.length() == 1);  // 1 digit entered
            
    if (qPIR_Time.length() == 2);   // 2 digits entered
    {
      if(isDigit (qPIR_Time[0]) && isDigit (qPIR_Time[1]))  
      {         // only if digits are numerical 
        Value = (qPIR_Time[1] - '0') + ((qPIR_Time[0] - '0') * 10); 
        Status = true;
      }           
    }  // end of if (qPIR_Time.length() == 2);   // 2 digits entered                      
    if (qPIR_Time.length() == 3);   // 3 digits entered
    {                     // only if digits are numerical 
      if(isDigit (qPIR_Time[0]) && isDigit (qPIR_Time[1]) && isDigit (qPIR_Time[2]))
      {
        Value = (qPIR_Time[2] - '0') + ((qPIR_Time[1] - '0') * 10) + ((qPIR_Time[0] - '0') * 100) ; 
        Status = true;                
      }              
    }    // end of if (qPIR_Time.length() == 3);   // 3 digits entered        
            
    if (Status)    // if valid entry made
    {          
       EEPROM.write(EEPROM_PIR_Time, Value);
          // PIR_Time = Value;   // save to current working memory 
    }
        // ........................ Process Pump Protection start delay timer .................

    Value = 0;
    i = 0; 
    Status = false;
            // validate and convert web entry to a decimal number for storage
    if (qStart_Up_Delay.length() == 1);  // 1 digit entered
    {
      if(isDigit (qStart_Up_Delay[0]))  // only if digit is numerical 
      {
        Value = qStart_Up_Delay[0] - '0'; 
        Status = true;
      }
    } // end of if (qStart_Up_Delay.length() == 1);  // 1 digit entered
            
    if (qStart_Up_Delay.length() == 2);   // 2 digits entered
    {
      if(isDigit (qStart_Up_Delay[0]) && isDigit (qStart_Up_Delay[1]))  
      {         // only if digits are numerical 
        Value = (qStart_Up_Delay[1] - '0') + ((qStart_Up_Delay[0] - '0') * 10); 
        Status = true;
      }           
    }  // end of if (qStart_Up_Delay.length() == 2);   // 2 digits entered                      
            
    if (Status) EEPROM.write(EEPROM_Pump_Protection_Start_Up_Delay_Time, Value); // if valid entry made

    // --------------------------- Process Pump Protection Dry Time delay timer ------------------------
    Value = 0;
    i = 0;
    Status = false;
            // validate and convert web entry to a decimal number for storage
    if (qDry_Time_Delay.length() == 1);  // 1 digit entered
    {
      if(isDigit (qDry_Time_Delay[0]))  // only if digit is numerical 
      {
        Value = qDry_Time_Delay[0] - '0'; 
        Status = true;
      }
    } // end of if (qDry_Time_Delay.length() == 1);  // 1 digit entered
            
    if (qDry_Time_Delay.length() == 2);   // 2 digits entered
    {
      if(isDigit (qDry_Time_Delay[0]) && isDigit (qDry_Time_Delay[1]))  
      {         // only if digits are numerical 
        Value = (qDry_Time_Delay[1] - '0') + ((qDry_Time_Delay[0] - '0') * 10); 
        Status = true;
      }           
    }  // end of if (qDry_Time_Delay.length() == 2);   // 2 digits entered                      
            
    if (Status) EEPROM.write(EEPROM_Pump_Protection_Dry_Time, Value); // if valid entry made
            
       // ........................ Process AUX 1 mode ..............................                      
  Value = 0;
  Value = qAUX1_Mode[0] - '0'; 
  EEPROM.write(EEPROM_AUX_Mode, Value);                      
        // ........................ Process AUX 2 mode .............................                        
  if(No_Of_AUX >= 2)  // if there is a second AUX enabled
  {
    Value = qAUX2_Mode[0] - '0'; 
    EEPROM.write(EEPROM_AUX_Mode+1, Value);
  }
        // ........................ Process AUX 3 mode ............................. 
  if(No_Of_AUX == 3)  // if there is a third AUX input fitted
  {
    Value = qAUX3_Mode[0] - '0'; 
    EEPROM.write(EEPROM_AUX_Mode+2, Value);
  }
  EEPROM.commit();      // Lock in EEPROM changes
  Download_From_EEPROM_Output_And_Input_Settings(false);  // download EEPROM to working memory
  Success_Message(false);  // send success message to AP web page
  Heartbeat_Tick();   // Feed the HW watchdog!
 });   // end of serverAP.on("/setting14", []() 
    // -----------------------------------------------------------------------
 serverAP.on("/setting15", []()    // WiFi Set up
 {
        IPAddress ip = WiFi.softAPIP();
        String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
        content = "<!DOCTYPE HTML>\r\n<html>";
        content += "<h3>" + HostName + " WiFi Configuration Page</h3>";
               
        content += "<fieldset>"; 
        content += "<legend><b>Current stored Network details</b></legend>"; 
        content += "IP address " + ipStr + "<br>";
        content += "SSID = " + esid + "<br>";
        content += "Device name = " + HostName;        
        content += "</fieldset>";   
        
        content += "<fieldset>";             
        content += "<legend><b>Detected Networks ... </b></legend>";
        content += st ;
        content += "</fieldset>"; 
                
        content += "<form action='setting' autocomplete = 'off'></p>";        
        content += "<fieldset>";       
        content += "<legend><b>Input new settings (blank fields will not be updated)</b></legend>";
        content += "<label>New SSID: (Max 20 char) </label>  <input name='ssid' size = '20' length=20>"; 
        content += "<br><label>Password: (Max 20 char) <&nbsp> </label> <input name='pass' size = '20' length=20>";
        content += "<br><label>Name: (Max 20 char)<&nbsp><&nbsp><&nbsp> </label> <input name='name' size = '20' length=20>";              
        content += "</fieldset>"; 
                
        content += "<p><input type='submit' value = 'Upload new settings to the device'> </form>";
        content += "<p><a href='http://192.168.8.200'> Return to the Main Configuration Menu page </a>";
        content += "</form></html>"; 
        serverAP.send(200, "text/html", content); 
        Heartbeat_Tick();   // Feed the HW watchdog!        
 });   // end of serverAP.on("/setting", []() 
  // -----------------------------------------------------------------------     
 serverAP.on("/setting16", []()    // Relay On Timers
 {
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<h3>" + HostName;
    content += " Relay Output Timer Page</h3>";
   
    content += "<fieldset>"; 
    content += "<legend><b>The time that the relay remains ON after switching</b></legend>";
    content += "<p><form action='setting3'></p>";        
    content += "<p><label>Relay 1 - " + Relay_Descriptors[0] + " Timer (1-240 mins, 0 = Timer OFF): </label>"; 
    content += "<input type = 'number' name='Switch_Timer1' + value = ";
    content += String(Relay_On_Time_Parameter[0]) + " length=3 size = '3' min='1' max = '240'>";
    if (No_Of_Relays >= 2) 
    {
      content += "<p><label>Relay 2 - " + Relay_Descriptors[1] + " Timer (1-240 mins, 0 = Timer OFF): </label> ";
      content += "<input type = 'number' name='Switch_Timer2' + value = " ;
      content += String(Relay_On_Time_Parameter[1]) + " length=3 size = '3' min='1' max = '240'>";
    }
    if (No_Of_Relays == 3) 
    {
      content += "<p><label>Relay 3 - " + Relay_Descriptors[2] + " Timer (1-240 mins, 0 = Timer OFF): </label> ";
      content += "<input type = 'number' name='Switch_Timer3' + value = ";
      content += String(Relay_On_Time_Parameter[2]) + " length=3 size = '3' min='1' max = '240'></p>";
    }
    content += "</fieldset>";     
    
    content += "<p><input type='submit' value = 'Upload new settings to the device'> </form>";
    content += "<p><a href='http://192.168.8.200'> Return to the Main Configuration Menu page </a>";
    content += "</form> </html>";  
    serverAP.send(200, "text/html", content);
    Heartbeat_Tick();   // Feed the HW watchdog! 
 });   // end of serverAP.on("/setting16", []() 
  // -----------------------------------------------------------------------     
 serverAP.on("/setting17", []()    // Timer control Relay 1
 {
    content = "<!DOCTYPE HTML> \r\n<html>";
    Timer_Page_Relay1();
    serverAP.send(200, "text/html", content); 
    Heartbeat_Tick();   // Feed the HW watchdog!
 });   // end of serverAP.on("/setting17", []() 
  // -----------------------------------------------------------------------     
 serverAP.on("/setting18", []()    // Timer control relay 2
 {
    content = "<!DOCTYPE HTML> \r\n<html>";      
    Timer_Page_Relay2();
    serverAP.send(200, "text/html", content);
    Heartbeat_Tick();   // Feed the HW watchdog! 
 });   // end of serverAP.on("/setting18", []() 
  // -----------------------------------------------------------------------     
 serverAP.on("/setting19", []()    //  Timer control relay 3
 {
    content = "<!DOCTYPE HTML> \r\n<html>";      
    Timer_Page_Relay3();
    serverAP.send(200, "text/html", content);
    Heartbeat_Tick();   // Feed the HW watchdog! 
 });   // end of serverAP.on("/setting19", []() 
  // -----------------------------------------------------------------------     
 serverAP.on("/setting20", []()    // Quit
 {
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "Device will now reset and attempt login";         
    serverAP.send(200, "text/html", content);  // send message to AP Webpage
    Reset_Device("From Access Point"); 
 });   // end of serverAP.on("/setting20", []() 

serverAP.on("/setting21", []()    // Disable Access point (if started by soft switch
 {
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "Soft Access Point Switch has been reset";  
    content += "<br>The Access Point will now close";       
    serverAP.send(200, "text/html", content);  // send message to AP Webpage
    EEPROM.write(EEPROM_Soft_AP_Switch,false);
    EEPROM.commit();
    Soft_AP_Switch = false; 
 });   // end of serverAP.on("/setting21", []() 

serverAP.on("/setting22", []()    // Display System settings page
 {
    content = "<!DOCTYPE HTML> \r\n<html>";
    content += "<h3>" + HostName;
    content += " System Settings & Control Flags Status  " + Firmware_Version + "</h3>";
    content+= "Current clock time = ";
    content += String(Clock_Hour) + ":";      
    if (Clock_Minute > 9) content += String(Clock_Minute);
    else content += "0" + String(Clock_Minute);
    switch (Clock_Week_Day)
    {
      case 1:
      content += " Sunday, ";
      break;
      case 2: 
      content += " Monday, ";
      break;
      case 3:
      content += " Tuesday, ";
      break;
      case 4:
      content += " Wednesday, ";
      break;
      case 5:
      content += " Thursday, ";
      break;
      case 6:
      content += " Friday, ";
      break;
      case 7:
      content += " Saturday, ";
      break;
    }     
    content += " - Reload this page to refresh clock<p>";    
    content += "<p><form action = 'setting23'>";  
    
    content += "<fieldset>"; 
    content += "<legend><b>Current Stored Network Details</b></legend>"; 
    content += "SSID = " + esid + "<br>";
    content += "Device Name = " + HostName;
    content += "</fieldset>"; 
    
    content += "<fieldset>"; 
    content += "<legend><b>Program control flags & variables - read only (refresh page to update)</b></legend>";     
    content += "No of configured relays = " + String(No_Of_Relays); 
    content += "<br>No of enabled AUX inputs = " + String(No_Of_AUX);
    content += "<br>The Soft Access Point Switch is ";
    if (Soft_AP_Switch) content += "ON"; else content += "OFF";
    content += "<br>The current NTP_Time_Interval (mS) = " + String(NTP_Time_Interval);
    content += "<br>The last NTP request was a ";
    if (NTP_Resolved) content += "Success"; else content += "Failure";
    content += "<br>Diagnostic messages on the serial port are ";
    if (Enable_Messages) content += "Enabled"; else content += "Disabled"; 
    content += "<br>Automatic timed reset is currently ";
    if(Timer_Reset_Enable) content += "Enabled"; else content += "Disabled";
    content += "<br>Current Relay 1 ON timer (mins) = " + String(Relay_On_Timers[0]);   
    if (No_Of_Relays >= 2) content += "<br>Current Relay 2 ON timer (mins) = " + String(Relay_On_Timers[1]);    
    if (No_Of_Relays == 3) content += "<br>Current Relay 3 ON timer (mins) = " + String(Relay_On_Timers[2]);     
    content += "</fieldset>";  
            
    content += "<fieldset>"; 
    content += "<legend><b>Watchdog & Automatic Timer Reset of Device Settings </b></legend>"; 
    content += "<input type = 'radio' name = 'Watchdog_Type' value = 'H'";
    if(WatchDog_Type == Hardware) content += "checked";
    content+= ">Hardware Watchdog  ";
    content += "<input type = 'radio' name = 'Watchdog_Type' value = 'S'";
    if(WatchDog_Type == Software) content += "checked";
    content += ">Software Watchdog";
  
    content += "<br>Automatic Timer Reset at: <input type = 'time' name = 'Timer_Reset_Clock'  ";
    String Time = Timer_Reset_Clock_Time_To_String ();   // get time  in string form
    content += "value = " + Time + ">";      
    content += "<input type = 'checkbox' name = 'Timer_Reset_Clock_Enable'  value = '1' ";   
    if (Timer_Reset_Enable) content += " checked>"; else content += ">";  
    content += " Automatic Timer Reset Function Enabled";
    content += "</fieldset>"; 
            
    content += "<p><input type='submit' value = 'Upload new settings to the device'>";   
    content += "<p><a href='http://192.168.8.200'> Return to the Main Configuration Menu page without saving </a>";
    content += "</form> </html>";       
    serverAP.send(200, "text/html", content);  // send message to AP Webpage

 });   // end of serverAP.on("/setting22", []() 

serverAP.on("/setting23", []()    // Process system settings page
 {
    String Value;
    String qTimer_Reset_Clock_Enable = serverAP.arg("Timer_Reset_Clock_Enable");
    String qTimer_Reset_Clock = serverAP.arg("Timer_Reset_Clock");
    String qWatchdog_Type = serverAP.arg("Watchdog_Type");
    if (qTimer_Reset_Clock.length() > 0)
    {
      EEPROM.write(EEPROM_Timer_Reset_Clock_Mins, Get_Decimal_Mins_From_Web_Time_Value(qTimer_Reset_Clock)); 
      EEPROM.write(EEPROM_Timer_Reset_Clock_Hrs, Get_Decimal_Hours_From_Web_Time_Value(qTimer_Reset_Clock));
    }
   
    Value = qWatchdog_Type; 
    if (Value == "H") EEPROM.write(EEPROM_WatchDog_Type, Hardware);
    if (Value == "S") EEPROM.write(EEPROM_WatchDog_Type, Software);         
    if(qTimer_Reset_Clock_Enable == "1") EEPROM.write(EEPROM_Timer_Reset_Enable, true);  
    else EEPROM.write(EEPROM_Timer_Reset_Enable, false);      
    
    EEPROM.commit();      // Lock in EEPROM changes
    WatchDog_Type = EEPROM.read(EEPROM_WatchDog_Type);   // set working memory      
    Download_Timer_Reset_Clock_From_EEPROM(false);  // download new EEPROM values to working memory    
    Success_Message(false);  // send success message to AP web page   
 });   // end of serverAP.on("/setting23", []() 
}   // end of void Upload_Device_Configuration_Web_Page()
  // *****************************************************************************
void Set_Up_Access_Point()    // set up & create an access point and web page to allow the login details
                              // to be changed - will reset the board after the changes have been entered
                              // Normal login to WiFi network using the stored details
{
  WiFi.mode(WIFI_AP_STA);
  if (Enable_Messages) 
  { 
      Serial.println(""); 
      Serial.print(F("Starting up "));
      Serial.print(HostName);
      Serial.println(F(" Setup Access Point"));
  }
  Heartbeat_Tick();   // Feed the HW watchdog! 
  int n = WiFi.scanNetworks();
  st = "<ol>";
  for (int i = 0; i < n; ++i)
    {
      // add SSID and RSSI to string st for each network found
      st += "<li>";
      st += WiFi.SSID(i);
      Heartbeat_Tick();   // Feed the HW watchdog!
      st += " (";
      st += WiFi.RSSI(i);
      st += ")";
      st += (WiFi.encryptionType(i) == ENC_TYPE_NONE)?" ":"*";
      st += "</li>";
    }   // end of for (int i = 0; i < n; ++i)
  st += "</ol>";

    // ************* delete these 4 lines if you wish to use default IP address of 192.168.4.1
  IPAddress ip(192,168,8,200);        // Give Access point a preferred IP Address
  IPAddress gateway(192,168,8,200);   // Give Access point a preferred gateway address
  IPAddress subnet(255,255,255,0);    // Give Access point a preferred subnet address
  WiFi.softAPConfig(ip,gateway,subnet);
    // ***************************************************************************************
  ssid = HostName + " - Setup" ;  // AP server name is same as the device name
  WiFi.softAP(ssid.c_str(), passphrase.c_str());     // Create Access Point
  Heartbeat_Tick();   // Feed the HW watchdog!
  Upload_Device_Configuration_Web_Page();  // Create and upload the configuration web page
  
  serverAP.begin();   // Start the access point webserver
  if (Enable_Messages)  
  {
      Serial.print("Connect to Access Point "); Serial.println(ssid); 
      Serial.print("Web page IP address "); Serial.println(WiFi.softAPIP());
      Serial.println(F("for Device Setup")); 
  }
}   // end of void Set_Up_Access_Point(void) 
  // *****************************************************************************


